/* hugeCalc.c */

#include "hugeCalc.h"

#ifdef _DEBUG
	/* printf(..) */
	#if 1
		#include <stdio.h>
		#define _PRINTF _tprintf
	#endif
#endif

/* static */
enum FunIndex
{
	fnHC_getVer = 0,
	fnHC_getSN,

	fnHC_getExportFunNums,
	fnHC_getLicenseLevel,

	fnHC_getLastError,

	fnHC_setTerminate,
	fnHC_isTerminated,

	fnHC_seedRandom,

	fnHC_resetTimer,
	fnHC_enableTimer,
	fnHC_getTimer,
	fnHC_getTimerStr,

	fnHC_isPrime,
	fnHC_getPrimePi,
	fnHC_getPrime,
	fnHC_previousPrime,
	fnHC_nextPrime,
	fnHC_getPrimeCount,
	fnHC_getPrimeList,

	fnHC_EulerPhi,
	fnHC_JacobiSymbol,
	fnHC_MultiplicativeOrder,
	fnHC_PrimitiveRoot,

	fnHC_gcd,
	fnHC_gcd_v32,
	fnHC_gcdEx,
	fnHC_invertMod,
	fnHC_lcm,
	fnHC_powMod,



#ifndef _NO_HI
	fnHI_abs,
	fnHI_add,
	fnHI_add_u32,
	fnHI_bitAnd,
	fnHI_bitLShift,
	fnHI_bitRShift,
	fnHI_bitOr,
	fnHI_bitXor,
	fnHI_ceil,
	fnHI_combination,
	fnHI_compareAbs_hi,
	fnHI_compareAbs_s32,
	fnHI_compareAbs_u32,
	fnHI_compare_hi,
	fnHI_compare_s32,
	fnHI_compare_u32,
	fnHI_decLShift,
	fnHI_decRShift,
	fnHI_delete,
	fnHI_divRem,
	fnHI_div_s32,
	fnHI_factorial,
	fnHI_factorial2,
	fnHI_fibonacci,
	fnHI_floor,
	fnHI_freeStrBuffer,
	fnHI_gcd,
	fnHI_gcdEx,
	fnHI_gcd_vhi,
	fnHI_generatePrime,
	fnHI_getBits,
	fnHI_getCount,
	fnHI_getDigits,
	fnHI_getHexStr,
	fnHI_getSign,
	fnHI_getStr,
	fnHI_getStrRadix,
	fnHI_getTailDecZeros,
	fnHI_get_s32,
	fnHI_get_s64,
	fnHI_get_u32,
	fnHI_get_u64,
	fnHI_invertMod,
	fnHI_invertMod_u32,
	fnHI_isAbsOne,
	fnHI_isEven,
	fnHI_isOdd,
	fnHI_isPrime,
	fnHI_isZero,
	fnHI_lcm,
	fnHI_lcm_v32,
	fnHI_lcm_vhi,
	fnHI_log,
	fnHI_log_u32,
	fnHI_lucas,
	fnHI_mod,
	fnHI_modPowTen,
	fnHI_mul,
	fnHI_mulMod,
	fnHI_mul_u32,
	fnHI_negate,
	fnHI_new,
	fnHI_nextPrime,
	fnHI_permutation,
	fnHI_pow,
	fnHI_powMod,
	fnHI_powMod_u32,
	fnHI_powMod_u32_u32,
	fnHI_previousPrime,
	fnHI_primeFactorial,
	fnHI_primorial,
	fnHI_product_v32,
	fnHI_product_vhi,
	fnHI_random,
	fnHI_rootRem,
	fnHI_setHexStr,
	fnHI_set_hi,

#ifndef _NO_HX
	fnHI_set_hx,
#endif	/* #ifndef _NO_HX */

#ifndef _NO_RC
	fnHI_set_rc,
#endif	/* #ifndef _NO_RC */

	fnHI_set_s32,
	fnHI_set_s64,
	fnHI_set_str,
	fnHI_set_u32,
	fnHI_set_u64,
	fnHI_sub,
	fnHI_sub_u32,
	fnHI_sumsOfLikePowers_v32,
	fnHI_sumsOfLikePowers_vhi,
	fnHI_swap,
	fnHI_testPrimality,
	fnHI_truncate,
#endif	/* #ifndef _NO_HI */



#ifndef _NO_HX
	fnHX_abs,
	fnHX_add,
	fnHX_add_u32,
	fnHX_bitAnd,
	fnHX_bitLShift,
	fnHX_bitRShift,
	fnHX_bitOr,
	fnHX_bitXor,
	fnHX_ceil,
	fnHX_combination,
	fnHX_compareAbs_hx,
	fnHX_compareAbs_s32,
	fnHX_compareAbs_u32,
	fnHX_compare_hx,
	fnHX_compare_s32,
	fnHX_compare_u32,
	fnHX_delete,
	fnHX_divRem,
	fnHX_div_s32,
	fnHX_factorial,
	fnHX_factorial2,
	fnHX_fibonacci,
	fnHX_floor,
	fnHX_freeStrBuffer,
	fnHX_gcd,
	fnHX_gcdEx,
	fnHX_gcd_vhx,
	fnHX_generatePrime,
	fnHX_getBits,
	fnHX_getCount,
	fnHX_getDigits,
	fnHX_getHexStr,
	fnHX_getSign,
	fnHX_getStr,
	fnHX_getStrRadix,
	fnHX_getTailBitZeros,
	fnHX_getText,
	fnHX_get_s32,
	fnHX_get_s64,
	fnHX_get_u32,
	fnHX_get_u64,
	fnHX_invertMod,
	fnHX_invertMod_u32,
	fnHX_isAbsOne,
	fnHX_isBitOne,
	fnHX_isEven,
	fnHX_isOdd,
	fnHX_isPrime,
	fnHX_isZero,
	fnHX_lcm,
	fnHX_lcm_v32,
	fnHX_lcm_vhx,
	fnHX_log,
	fnHX_log_u32,
	fnHX_lucas,
	fnHX_mod,
	fnHX_modPowTwo,
	fnHX_mul,
	fnHX_mulMod,
	fnHX_mul_u32,
	fnHX_negate,
	fnHX_new,
	fnHX_nextPrime,
	fnHX_permutation,
	fnHX_pow,
	fnHX_powMod,
	fnHX_powMod_u32,
	fnHX_powMod_u32_u32,
	fnHX_previousPrime,
	fnHX_primeFactorial,
	fnHX_primorial,
	fnHX_product_v32,
	fnHX_product_vhx,
	fnHX_random,
	fnHX_rootRem,
	fnHX_setHexStr,
	fnHX_setText,

#ifndef _NO_HI
	fnHX_set_hi,
#endif	/* #ifndef _NO_HI */

	fnHX_set_hx,

#ifndef _NO_RC
	fnHX_set_rc,
#endif	/* #ifndef _NO_RC */

	fnHX_set_s32,
	fnHX_set_s64,
	fnHX_set_str,
	fnHX_set_u32,
	fnHX_set_u64,
	fnHX_sub,
	fnHX_sub_u32,
	fnHX_sumsOfLikePowers_v32,
	fnHX_sumsOfLikePowers_vhx,
	fnHX_swap,
	fnHX_testPrimality,
	fnHX_truncate,
#endif  /* #ifndef _NO_HX */



#ifndef _NO_RC
	fnRC_clearVector,
	fnRC_convert2Radix,
	fnRC_delete,
	fnRC_getRadix,
	fnRC_getCount,
	fnRC_getSign,
	fnRC_getVector,
	fnRC_get_s32,
	fnRC_get_s64,
	fnRC_get_u32,
	fnRC_get_u64,
	fnRC_new,
	fnRC_new_str,
	fnRC_resetRadix,
	fnRC_resetSign,
	fnRC_resetVector,

#ifndef _NO_HI
	fnRC_set_hi,
#endif	/* #ifndef _NO_RC */

#ifndef _NO_HX
	fnRC_set_hx,
#endif	/* #ifndef _NO_HX */

	fnRC_set_rc,
	fnRC_set_s32,
	fnRC_set_s64,
	fnRC_set_u32,
	fnRC_set_u64,
	fnRC_sumOfDigits,
#endif	/* #ifndef _NO_RC */


	_fnFunNums,
};	/* end "enum FunIndex =" */



static HINSTANCE s_hInstDLL = NULL;
static FARPROC s_pfFun[ _fnFunNums ];

const BOOL hugeCalcDLLInit( const LPCTSTR lpszDLLPath )
{
	const char lpProcName[ _fnFunNums ][ 32 ] =
	{
	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HC_getVerA",
		"HC_getSNA",
	#else
		"HC_getVerW",
		"HC_getSNW",
	#endif

		"HC_getExportFunNums",
		"HC_getLicenseLevel",

		"HC_getLastError",

		"HC_setTerminate",
		"HC_isTerminated",

		"HC_seedRandom",

		"HC_resetTimer",
		"HC_enableTimer",
		"HC_getTimer",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HC_getTimerStrA",
	#else
		"HC_getTimerStrW",
	#endif

		"HC_isPrime",
		"HC_getPrimePi",
		"HC_getPrime",
		"HC_previousPrime",
		"HC_nextPrime",
		"HC_getPrimeCount",
		"HC_getPrimeList",

		"HC_EulerPhi",
		"HC_JacobiSymbol",
		"HC_MultiplicativeOrder",
		"HC_PrimitiveRoot",

		"HC_gcd",
		"HC_gcd_v32",
		"HC_gcdEx",
		"HC_invertMod",
		"HC_lcm",
		"HC_powMod",



#ifndef _NO_HI
		"HI_abs",
		"HI_add",
		"HI_add_u32",
		"HI_bitAnd",
		"HI_bitLShift",
		"HI_bitRShift",
		"HI_bitOr",
		"HI_bitXor",
		"HI_ceil",
		"HI_combination",
		"HI_compareAbs_hi",
		"HI_compareAbs_s32",
		"HI_compareAbs_u32",
		"HI_compare_hi",
		"HI_compare_s32",
		"HI_compare_u32",
		"HI_decLShift",
		"HI_decRShift",
		"HI_delete",
		"HI_divRem",
		"HI_div_s32",
		"HI_factorial",
		"HI_factorial2",
		"HI_fibonacci",
		"HI_floor",
		"HI_freeStrBuffer",
		"HI_gcd",
		"HI_gcdEx",
		"HI_gcd_vhi",
		"HI_generatePrime",
		"HI_getBits",
		"HI_getCount",
		"HI_getDigits",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HI_getHexStrA",
	#else
		"HI_getHexStrW",
	#endif

		"HI_getSign",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HI_getStrA",
		"HI_getStrRadixA",
	#else
		"HI_getStrW",
		"HI_getStrRadixW",
	#endif

		"HI_getTailDecZeros",
		"HI_get_s32",
		"HI_get_s64",
		"HI_get_u32",
		"HI_get_u64",
		"HI_invertMod",
		"HI_invertMod_u32",
		"HI_isAbsOne",
		"HI_isEven",
		"HI_isOdd",
		"HI_isPrime",
		"HI_isZero",
		"HI_lcm",
		"HI_lcm_v32",
		"HI_lcm_vhi",
		"HI_log",
		"HI_log_u32",
		"HI_lucas",
		"HI_mod",
		"HI_modPowTen",
		"HI_mul",
		"HI_mulMod",
		"HI_mul_u32",
		"HI_negate",
		"HI_new",
		"HI_nextPrime",
		"HI_permutation",
		"HI_pow",
		"HI_powMod",
		"HI_powMod_u32",
		"HI_powMod_u32_u32",
		"HI_previousPrime",
		"HI_primeFactorial",
		"HI_primorial",
		"HI_product_v32",
		"HI_product_vhi",
		"HI_random",
		"HI_rootRem",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HI_setHexStrA",
	#else
		"HI_setHexStrW",
	#endif

		"HI_set_hi",

#ifndef _NO_HX
		"HI_set_hx",
#endif	/* #ifndef _NO_HX */

#ifndef _NO_RC
		"HI_set_rc",
#endif	/* #ifndef _NO_RC */

		"HI_set_s32",
		"HI_set_s64",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HI_set_strA",
	#else
		"HI_set_strW",
	#endif

		"HI_set_u32",
		"HI_set_u64",
		"HI_sub",
		"HI_sub_u32",
		"HI_sumsOfLikePowers_v32",
		"HI_sumsOfLikePowers_vhi",
		"HI_swap",
		"HI_testPrimality",
		"HI_truncate",
#endif	/* #ifndef _NO_HI */



#ifndef _NO_HX
		"HX_abs",
		"HX_add",
		"HX_add_u32",
		"HX_bitAnd",
		"HX_bitLShift",
		"HX_bitRShift",
		"HX_bitOr",
		"HX_bitXor",
		"HX_ceil",
		"HX_combination",
		"HX_compareAbs_hx",
		"HX_compareAbs_s32",
		"HX_compareAbs_u32",
		"HX_compare_hx",
		"HX_compare_s32",
		"HX_compare_u32",
		"HX_delete",
		"HX_divRem",
		"HX_div_s32",
		"HX_factorial",
		"HX_factorial2",
		"HX_fibonacci",
		"HX_floor",
		"HX_freeStrBuffer",
		"HX_gcd",
		"HX_gcdEx",
		"HX_gcd_vhx",
		"HX_generatePrime",
		"HX_getBits",
		"HX_getCount",
		"HX_getDigits",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HX_getHexStrA",
	#else
		"HX_getHexStrW",
	#endif

		"HX_getSign",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HX_getStrA",
		"HX_getStrRadixA",
	#else
		"HX_getStrW",
		"HX_getStrRadixW",
	#endif

		"HX_getTailBitZeros",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HX_getTextA",
	#else
		"HX_getTextW",
	#endif

		"HX_get_s32",
		"HX_get_s64",
		"HX_get_u32",
		"HX_get_u64",
		"HX_invertMod",
		"HX_invertMod_u32",
		"HX_isAbsOne",
		"HX_isBitOne",
		"HX_isEven",
		"HX_isOdd",
		"HX_isPrime",
		"HX_isZero",
		"HX_lcm",
		"HX_lcm_v32",
		"HX_lcm_vhx",
		"HX_log",
		"HX_log_u32",
		"HX_lucas",
		"HX_mod",
		"HX_modPowTwo",
		"HX_mul",
		"HX_mulMod",
		"HX_mul_u32",
		"HX_negate",
		"HX_new",
		"HX_nextPrime",
		"HX_permutation",
		"HX_pow",
		"HX_powMod",
		"HX_powMod_u32",
		"HX_powMod_u32_u32",
		"HX_previousPrime",
		"HX_primeFactorial",
		"HX_primorial",
		"HX_product_v32",
		"HX_product_vhx",
		"HX_random",
		"HX_rootRem",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HX_setHexStrA",
		"HX_setTextA",
	#else
		"HX_setHexStrW",
		"HX_setTextW",
	#endif

#ifndef _NO_HI
		"HX_set_hi",
#endif	/* #ifndef _NO_HI */

		"HX_set_hx",

#ifndef _NO_RC
		"HX_set_rc",
#endif	/* #ifndef _NO_RC */

		"HX_set_s32",
		"HX_set_s64",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"HX_set_strA",
	#else
		"HX_set_strW",
	#endif

		"HX_set_u32",
		"HX_set_u64",
		"HX_sub",
		"HX_sub_u32",
		"HX_sumsOfLikePowers_v32",
		"HX_sumsOfLikePowers_vhx",
		"HX_swap",
		"HX_testPrimality",
		"HX_truncate",
#endif  /* #ifndef _NO_HX */



#ifndef _NO_RC
		"RC_clearVector",
		"RC_convert2Radix",
		"RC_delete",
		"RC_getRadix",
		"RC_getCount",
		"RC_getSign",
		"RC_getVector",
		"RC_get_s32",
		"RC_get_s64",
		"RC_get_u32",
		"RC_get_u64",
		"RC_new",

	#if !( defined( UNICODE ) || defined( _UNICODE ))
		"RC_new_strA",
	#else
		"RC_new_strW",
	#endif

		"RC_resetRadix",
		"RC_resetSign",
		"RC_resetVector",

#ifndef _NO_HI
		"RC_set_hi",
#endif	/* #ifndef _NO_RC */

#ifndef _NO_HX
		"RC_set_hx",
#endif	/* #ifndef _NO_HX */

		"RC_set_rc",
		"RC_get_s32",
		"RC_get_s64",
		"RC_get_u32",
		"RC_get_u64",
		"RC_sumOfDigits",
#endif	/* #ifndef _NO_RC */

	};	/* end "const char lpProcName[ _fnFunNums ][ 32 ] =" */


	const _TCHAR szDLLName[] = { _T( "HugeCalc.dll" ) };
	_TCHAR szDLLPathName[ MAX_PATH ] = { _T( '\0' ) };
	UINT32 k;

	/* ___Release existing library___ */
	hugeCalcDLLFree();

	/* ___Load library___1st:specified dir 2nd:Window default dir___ */
	if ( NULL != lpszDLLPath )
	{
		_tcscat( szDLLPathName, lpszDLLPath );
	}
	_tcscat( szDLLPathName, szDLLName );

	if ( NULL == ( s_hInstDLL = LoadLibrary( szDLLPathName )) \
		&& NULL == ( s_hInstDLL = LoadLibrary( szDLLName )))
	{
	#ifdef _PRINTF
		_PRINTF( _T( "HugeCalc.dll V8.x or laster vesion is required!\r\n\r\n" ));
	#endif

		return FALSE;
	}

	for ( k = 0; _fnFunNums != k; ++k )
	{
		if ( NULL == ( s_pfFun[ k ] = GetProcAddress( s_hInstDLL, lpProcName[ k ] )))
		{
			#ifdef _PRINTF
				_PRINTF( _T( "GetProcAddress '%s' failed!\r\n\r\n" ), lpProcName[ k ] );
			#endif

			hugeCalcDLLFree();
			return FALSE;
		}
	}

#ifdef _PRINTF
	_PRINTF( _T( "====== 'HugeCalc' exported %u functions. ======\r\n\r\n" ), _fnFunNums );
#endif

	return TRUE;
}

void hugeCalcDLLFree( void )
{
	if ( NULL != s_hInstDLL )
	{
		FreeLibrary( s_hInstDLL );
		s_hInstDLL = NULL;
	}
}



	typedef const LPCTSTR (WINAPI* lpfHC_getVer)( void );

	typedef const LPCTSTR (WINAPI* lpfHC_getSN)( void );

	typedef const HCLicenseLevel (WINAPI* lpfHC_getLicenseLevel)( void );
	typedef const UINT32 (WINAPI* lpfHC_getExportFunNums)( const UINT32 u32Mask /*= _HC_Export_ANSI_C*/ );

	typedef const HCErrCode (WINAPI* lpfHC_getLastError)( void );

	/* It usefull when use multithread. */
	typedef void (WINAPI* lpfHC_setTerminate)( const BOOL bTerminate /*= TRUE*/ );
	typedef const BOOL (WINAPI* lpfHC_isTerminated)( void );

	typedef void (WINAPI* lpfHC_seedRandom)( const UINT32 u32Seed /*= 0*/ );

	/* before calculate, pls call bEnableTimer as TRUE, and after finishing call as FALSE */
	typedef void (WINAPI* lpfHC_resetTimer)( const UINT32 u32Timer /*= 0*/, const TimerUnit enumTimerUnit /*= TIMER_UNIT_us*/ );
	typedef void (WINAPI* lpfHC_enableTimer)( const BOOL bEnableTimer /*= TRUE*/ );
	typedef const UINT32 (WINAPI* lpfHC_getTimer)( const TimerUnit enumTimerUnit /*= TIMER_UNIT_us*/ );
	typedef const LPCTSTR (WINAPI* lpfHC_getTimerStr)( const FormatTime enumFormatTime /*= FT_DOT06SEC_s*/ );

	typedef const BOOL (WINAPI* lpfHC_isPrime)( const UINT32 u32Num );
	typedef const UINT32 (WINAPI* lpfHC_getPrimePi)( const UINT32 u32Num );
	typedef const UINT32 (WINAPI* lpfHC_getPrime)( const UINT32 u32Index );

	/* Returns the largest prime number less than the argument. */
	typedef const SINT32 (WINAPI* lpfHC_previousPrime)( const SINT32 s32Benchmark );
	/* Returns the smallest prime number greater than the argument. */
	typedef const SINT32 (WINAPI* lpfHC_nextPrime)( const SINT32 s32Benchmark );

	typedef const UINT32 (WINAPI* lpfHC_getPrimeCount)( const UINT32 u32LBound, const UINT32 u32UBound );
	typedef const UINT32 (WINAPI* lpfHC_getPrimeList)( UINT32 * const lpPrimeBuffer, const UINT32 u32BufferSize, const UINT32 u32LBound, const UINT32 u32UBound );

	/* gives the Euler totient function (n). */
	typedef const UINT32 (WINAPI* lpfHC_EulerPhi)( const UINT32 n );
	/* gives the Jacobi symbol(n/m). */
	typedef const SINT32 (WINAPI* lpfHC_JacobiSymbol)( const UINT32 n, const UINT32 m );
	/* gives the multiplicative order of k modulo n, defined as the smallest integer x such that k^x  1 mod n. */
	typedef const UINT32 (WINAPI* lpfHC_MultiplicativeOrder)( const UINT32 k, const UINT32 n );
	/* give a primitive root of n, where n is a prime power or twice a prime power. */
	typedef const UINT32 (WINAPI* lpfHC_PrimitiveRoot)( const UINT32 n );

	/* Greatest Common Divisor */
	typedef const UINT32 (WINAPI* lpfHC_gcd)( const UINT32 u32Num1, const UINT32 u32Num2 );

	typedef const UINT32 (WINAPI* lpfHC_gcd_v32)( const LPCVECTOR_UINT32 pVector );

	/* GcdEx: g = GcdEx)( x, y, u, v ) = u * x + v * y. g is always positive, even if one or both of u and v are negative. */
	typedef const UINT32 (WINAPI* lpfHC_gcdEx)( SINT32 * const x, SINT32 * const y, const SINT32 u, const SINT32 v );

	typedef const UINT32 (WINAPI* lpfHC_invertMod)( const UINT32 u32InvertBase, const UINT32 u32Mod );

	/* Lowest Common Multiple */
	typedef const UINT64 (WINAPI* lpfHC_lcm)( const UINT32 u32Num1, const UINT32 u32Num2 );

	/* PowMod */
	typedef const UINT32 (WINAPI* lpfHC_powMod)( const UINT32 u32Base, const UINT32 u32Exp, const UINT32 u32Mod );



#ifndef _NO_HI
	/* constructor */
	typedef HHUGEINT (WINAPI* lpfHI_new)( void );

	/* destructor */
	typedef void (WINAPI* lpfHI_delete)( HHUGEINT hHugeInt );

	typedef const UINT32 (WINAPI* lpfHI_getCount)( void );

	/* reload operators */
	typedef HHUGEINT (WINAPI* lpfHI_set_s32)( HHUGEINT hHugeInt, const SINT32 s32Num );
	typedef HHUGEINT (WINAPI* lpfHI_set_s64)( HHUGEINT hHugeInt, const SINT64 s64Num );
	typedef HHUGEINT (WINAPI* lpfHI_set_u32)( HHUGEINT hHugeInt, const UINT32 u32Num );
	typedef HHUGEINT (WINAPI* lpfHI_set_u64)( HHUGEINT hHugeInt, const UINT64 u64Num );
	typedef HHUGEINT (WINAPI* lpfHI_set_str)( HHUGEINT hHugeInt, const LPCTSTR lpszNum );
	typedef HHUGEINT (WINAPI* lpfHI_set_hi)( HHUGEINT hHugeInt, const HHUGEINT hRight );

#ifndef _NO_HX
	typedef HHUGEINT (WINAPI* lpfHI_set_hx)( HHUGEINT hHugeInt, const HHUGEINTX hRight );
#endif	/* #ifndef _NO_HX */

#ifndef _NO_RC
	typedef HHUGEINT (WINAPI* lpfHI_set_rc)( HHUGEINT hHugeInt, const HRADIXCONVERTER hRight );
#endif	/* #ifndef _NO_RC */

	typedef HHUGEINT (WINAPI* lpfHI_setHexStr)( HHUGEINT hHugeInt, const LPCTSTR lpszHexNum );

	/* Return non-zero if the value of )(*this) fits in SINT32, UINT32, SINT64 or UINT64, respectively. Otherwise, return zero. */
	typedef const SINT32 (WINAPI* lpfHI_get_s32)( const HHUGEINT hHugeInt );
	typedef const SINT64 (WINAPI* lpfHI_get_s64)( const HHUGEINT hHugeInt );
	typedef const UINT32 (WINAPI* lpfHI_get_u32)( const HHUGEINT hHugeInt );
	typedef const UINT64 (WINAPI* lpfHI_get_u64)( const HHUGEINT hHugeInt );

	/* CompareAbs */
	typedef const SINT32 (WINAPI* lpfHI_compareAbs_s32)( const HHUGEINT hLeft, const SINT32 s32Num );
	typedef const SINT32 (WINAPI* lpfHI_compareAbs_u32)( const HHUGEINT hLeft, const UINT32 u32Num );
	typedef const SINT32 (WINAPI* lpfHI_compareAbs_hi)( const HHUGEINT hLeft, const HHUGEINT hRight );

	/* Compare */
	typedef const SINT32 (WINAPI* lpfHI_compare_s32)( const HHUGEINT hLeft, const SINT32 s32Num );
	typedef const SINT32 (WINAPI* lpfHI_compare_u32)( const HHUGEINT hLeft, const UINT32 u32Num );
	typedef const SINT32 (WINAPI* lpfHI_compare_hi)( const HHUGEINT hLeft, const HHUGEINT hRight );

	/* get property */
	typedef const SIGN (WINAPI* lpfHI_getSign)( const HHUGEINT hHugeInt );
	typedef const BOOL (WINAPI* lpfHI_isZero)( const HHUGEINT hHugeInt );
	typedef const BOOL (WINAPI* lpfHI_isAbsOne)( const HHUGEINT hHugeInt );
	typedef const BOOL (WINAPI* lpfHI_isOdd)( const HHUGEINT hHugeInt );
	typedef const BOOL (WINAPI* lpfHI_isEven)( const HHUGEINT hHugeInt );
	typedef const BOOL (WINAPI* lpfHI_isPrime)( const HHUGEINT hHugeInt );
	typedef const PRIMALITY (WINAPI* lpfHI_testPrimality)( const HHUGEINT hHugeInt, const UINT32 u32Repeat /*= 5*/ );
	typedef const UINT32 (WINAPI* lpfHI_getBits)( const HHUGEINT hHugeInt );
	typedef const UINT32 (WINAPI* lpfHI_getDigits)( const HHUGEINT hHugeInt );
	typedef const UINT32 (WINAPI* lpfHI_getTailDecZeros)( const HHUGEINT hHugeInt );

	typedef HHUGEINT (WINAPI* lpfHI_bitLShift)( HHUGEINT hHugeInt, const UINT32 u32BitLShift );
	typedef HHUGEINT (WINAPI* lpfHI_bitRShift)( HHUGEINT hHugeInt, const UINT32 u32BitRShift );

	/* notice: base on decimal system !! */
	typedef HHUGEINT (WINAPI* lpfHI_decLShift)( HHUGEINT hHugeInt, const UINT32 u32DecLShift );
	typedef HHUGEINT (WINAPI* lpfHI_decRShift)( HHUGEINT hHugeInt, const UINT32 u32DecRShift );

	typedef HHUGEINT (WINAPI* lpfHI_bitAnd)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );
	typedef HHUGEINT (WINAPI* lpfHI_bitXor)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );
	typedef HHUGEINT (WINAPI* lpfHI_bitOr)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );


	typedef HHUGEINT (WINAPI* lpfHI_abs)( HHUGEINT hHugeInt );
	typedef HHUGEINT (WINAPI* lpfHI_negate)( HHUGEINT hHugeInt );
	typedef HHUGEINT (WINAPI* lpfHI_swap)( HHUGEINT hLeft, HHUGEINT hRight );

	typedef HHUGEINT (WINAPI* lpfHI_ceil)( HHUGEINT hHugeInt, const UINT32 u32DecDigits );
	typedef HHUGEINT (WINAPI* lpfHI_truncate)( HHUGEINT hHugeInt, const UINT32 u32DecDigits );
	typedef HHUGEINT (WINAPI* lpfHI_floor)( HHUGEINT hHugeInt, const UINT32 u32DecDigits );

	typedef HHUGEINT (WINAPI* lpfHI_random)( HHUGEINT hHugeInt, const UINT32 u32DecDigits );
	typedef HHUGEINT (WINAPI* lpfHI_generatePrime)( HHUGEINT hHugeInt, const UINT32 u32DecDigits );
	typedef HHUGEINT (WINAPI* lpfHI_previousPrime)( HHUGEINT hResult, const HHUGEINT hBenchmark );
	typedef HHUGEINT (WINAPI* lpfHI_nextPrime)( HHUGEINT hResult, const HHUGEINT hBenchmark );

	/* + */
	typedef HHUGEINT (WINAPI* lpfHI_add)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );
	typedef HHUGEINT (WINAPI* lpfHI_add_u32)( HHUGEINT hResult, const HHUGEINT hLeft, const UINT32 u32Num );

	/* - */
	typedef HHUGEINT (WINAPI* lpfHI_sub)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );
	typedef HHUGEINT (WINAPI* lpfHI_sub_u32)( HHUGEINT hResult, const HHUGEINT hLeft, const UINT32 u32Num );

	/* * */
	typedef HHUGEINT (WINAPI* lpfHI_mul)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );
	typedef HHUGEINT (WINAPI* lpfHI_mul_u32)( HHUGEINT hResult, const HHUGEINT hLeft, const UINT32 u32Num );

	/* Division, return quotient */
	typedef HHUGEINT (WINAPI* lpfHI_divRem)( HHUGEINT hQuotient, const HHUGEINT hDividend, const HHUGEINT hDivisor, HHUGEINT hRemainder /*= NULL*/ );
	typedef HHUGEINT (WINAPI* lpfHI_div_s32)( HHUGEINT hQuotient, const HHUGEINT hDividend, const SINT32 s32Divisor, SINT32 * const pRemainder /*= NULL*/ );

	/* % */
	typedef HHUGEINT (WINAPI* lpfHI_mod)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );

	/* Power */
	typedef HHUGEINT (WINAPI* lpfHI_pow)( HHUGEINT hResult, const HHUGEINT hBase, const UINT32 u32Exp );

	/* Extraction */
	typedef HHUGEINT (WINAPI* lpfHI_rootRem)( HHUGEINT hRoot, const HHUGEINT hRadicand, const UINT32 u32Exp, HHUGEINT hRemainder /*= NULL*/, BOOL * const pIsReal /*= NULL*/ );

	/* Logarithm */
	typedef const UINT32 (WINAPI* lpfHI_log_u32)( const HHUGEINT hHugeInt, const UINT32 u32Base, BOOL * const pIsExact /*= NULL*/ );
	typedef const UINT32 (WINAPI* lpfHI_log)( const HHUGEINT hHugeInt, const HHUGEINT hBase, BOOL * const pIsExact /*= NULL*/ );

	/* PrimeFactorial(n) gives the product of the first n primes. */
	typedef HHUGEINT (WINAPI* lpfHI_primeFactorial)( HHUGEINT hResult, const UINT32 u32Index );
	/* Primorial(n) gives the product of the primes less than or equal to n. */
	typedef HHUGEINT (WINAPI* lpfHI_primorial)( HHUGEINT hResult, const UINT32 u32Num );

	/* Factorial, Permutation, Combination */
	typedef HHUGEINT (WINAPI* lpfHI_factorial)( HHUGEINT hResult, const UINT32 n );
	typedef HHUGEINT (WINAPI* lpfHI_factorial2)( HHUGEINT hResult, const UINT32 n );
	typedef HHUGEINT (WINAPI* lpfHI_permutation)( HHUGEINT hResult, const UINT32 n, const UINT32 r );
	typedef HHUGEINT (WINAPI* lpfHI_combination)( HHUGEINT hResult, const UINT32 n, const UINT32 r );

	/* Fibonacci numbers */
	typedef HHUGEINT (WINAPI* lpfHI_fibonacci)( HHUGEINT hResult, const SINT32 n );

	/* Lucas numbers */
	typedef HHUGEINT (WINAPI* lpfHI_lucas)( HHUGEINT hResult, const SINT32 n );

	/* MulMod */
	typedef HHUGEINT (WINAPI* lpfHI_mulMod)( HHUGEINT hResult, const HHUGEINT hMultiplicand, const HHUGEINT hMultiplier, const HHUGEINT hMod );

	/* InvertMod: x = InvertMod)( b, m ) && !)(!x) <==> )( b * x ) mod m = 1 */
	typedef HHUGEINT (WINAPI* lpfHI_invertMod_u32)( HHUGEINT hResult, const UINT32 u32InvertBase, const HHUGEINT hMod );
	typedef HHUGEINT (WINAPI* lpfHI_invertMod)( HHUGEINT hResult, const HHUGEINT hInvertBase, const HHUGEINT hMod );

	/* PowMod */
	typedef const UINT32 (WINAPI* lpfHI_powMod_u32_u32)( const UINT32 u32Base, const HHUGEINT hExp, const UINT32 u32Mod );
	typedef HHUGEINT (WINAPI* lpfHI_powMod_u32)( HHUGEINT hResult, const UINT32 u32Base, const HHUGEINT hExp, const HHUGEINT hMod );
	typedef HHUGEINT (WINAPI* lpfHI_powMod)( HHUGEINT hResult, const HHUGEINT hBase, const HHUGEINT hExp, const HHUGEINT hMod );

	/* ModPowTen: *this %= 10^u32Exp */
	typedef HHUGEINT (WINAPI* lpfHI_modPowTen)( HHUGEINT hHugeInt, const UINT32 u32Exp );

	/* Greatest Common Divisor */
	typedef HHUGEINT (WINAPI* lpfHI_gcd)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );
	typedef HHUGEINT (WINAPI* lpfHI_gcd_vhi)( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector );

	/* GcdEx: g = GcdEx)( x, y, u, v ) = u * x + v * y. g is always positive, even if one or both of u and v are negative. */
	typedef HHUGEINT (WINAPI* lpfHI_gcdEx)( HHUGEINT hResult, HHUGEINT x, HHUGEINT y, const HHUGEINT u, const HHUGEINT v );

	/* Lowest Common Multiple */
	typedef HHUGEINT (WINAPI* lpfHI_lcm)( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight );
	typedef HHUGEINT (WINAPI* lpfHI_lcm_v32)( HHUGEINT hResult, const LPCVECTOR_UINT32 pVector );
	typedef HHUGEINT (WINAPI* lpfHI_lcm_vhi)( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector );

	typedef HHUGEINT (WINAPI* lpfHI_product_v32)( HHUGEINT hResult, const LPCVECTOR_UINT32 pVector );
	typedef HHUGEINT (WINAPI* lpfHI_product_vhi)( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector );

	/* if u32Exp==0, then call function: Product)( ... ); */
	typedef HHUGEINT (WINAPI* lpfHI_sumsOfLikePowers_v32)( HHUGEINT hResult, const LPCVECTOR_UINT32 pVector, const UINT32 u32Exp /*= 1*/ );
	typedef HHUGEINT (WINAPI* lpfHI_sumsOfLikePowers_vhi)( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector, const UINT32 u32Exp /*= 1*/ );

	/* Output */
	typedef const LPCTSTR (WINAPI* lpfHI_getStr)( const HHUGEINT hHugeInt, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ );

	typedef const LPCTSTR (WINAPI* lpfHI_getHexStr)( const HHUGEINT hHugeInt, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ );

	/* This function can convert the huge integer to a string of digits in another Radix system. */
	typedef const LPCTSTR (WINAPI* lpfHI_getStrRadix)( const HHUGEINT hHugeInt, const UINT32 u32Radix /*= 16*/, UINT32 * const pDigits /*= NULL*/, const BYTE byFormat /*= FS_DEFAULT*/, const UINT32 u32BandLength /*= 4*/, UINT32 * const pStrLen /*= NULL*/ );

	typedef const LPCTSTR (WINAPI* lpfHI_getText)( const HHUGEINT hHugeInt );

	typedef void (WINAPI* lpfHI_freeStrBuffer)( const HHUGEINT hHugeInt );
#endif	/* #ifndef _NO_HI */



#ifndef _NO_HX
	/* constructor */
	typedef HHUGEINTX (WINAPI* lpfHX_new)( void );

	/* destructor */
	typedef void (WINAPI* lpfHX_delete)( HHUGEINTX hHugeIntX );

	typedef const UINT32 (WINAPI* lpfHX_getCount)( void );

	/* reload operators */
	typedef HHUGEINTX (WINAPI* lpfHX_set_s32)( HHUGEINTX hHugeIntX, const SINT32 s32Num );
	typedef HHUGEINTX (WINAPI* lpfHX_set_s64)( HHUGEINTX hHugeIntX, const SINT64 s64Num );
	typedef HHUGEINTX (WINAPI* lpfHX_set_u32)( HHUGEINTX hHugeIntX, const UINT32 u32Num );
	typedef HHUGEINTX (WINAPI* lpfHX_set_u64)( HHUGEINTX hHugeIntX, const UINT64 u64Num );
	typedef HHUGEINTX (WINAPI* lpfHX_set_str)( HHUGEINTX hHugeIntX, const LPCTSTR lpszNum );

#ifndef _NO_HI
	typedef HHUGEINTX (WINAPI* lpfHX_set_hi)( HHUGEINTX hHugeIntX, const HHUGEINT hRight );
#endif	/* #ifndef _NO_HI */

	typedef HHUGEINTX (WINAPI* lpfHX_set_hx)( HHUGEINTX hHugeIntX, const HHUGEINTX hRight );

#ifndef _NO_RC
	typedef HHUGEINTX (WINAPI* lpfHX_set_rc)( HHUGEINTX hHugeIntX, const HRADIXCONVERTER hRight );
#endif	/* #ifndef _NO_RC */

	typedef HHUGEINTX (WINAPI* lpfHX_setHexStr)( HHUGEINTX hHugeIntX, const LPCTSTR lpszHexNum );

	typedef HHUGEINTX (WINAPI* lpfHX_setText)( HHUGEINTX hHugeIntX, const LPCTSTR lpszText );

	/* Return non-zero if the value of )(*this) fits in SINT32, UINT32, SINT64 or UINT64, respectively. Otherwise, return zero. */
	typedef const SINT32 (WINAPI* lpfHX_get_s32)( const HHUGEINTX hHugeIntX );
	typedef const SINT64 (WINAPI* lpfHX_get_s64)( const HHUGEINTX hHugeIntX );
	typedef const UINT32 (WINAPI* lpfHX_get_u32)( const HHUGEINTX hHugeIntX );
	typedef const UINT64 (WINAPI* lpfHX_get_u64)( const HHUGEINTX hHugeIntX );

	/* CompareAbs */
	typedef const SINT32 (WINAPI* lpfHX_compareAbs_s32)( const HHUGEINTX hLeft, const SINT32 s32Num );
	typedef const SINT32 (WINAPI* lpfHX_compareAbs_u32)( const HHUGEINTX hLeft, const UINT32 u32Num );
	typedef const SINT32 (WINAPI* lpfHX_compareAbs_hx)( const HHUGEINTX hLeft, const HHUGEINTX hRight );

	/* Compare */
	typedef const SINT32 (WINAPI* lpfHX_compare_s32)( const HHUGEINTX hLeft, const SINT32 s32Num );
	typedef const SINT32 (WINAPI* lpfHX_compare_u32)( const HHUGEINTX hLeft, const UINT32 u32Num );
	typedef const SINT32 (WINAPI* lpfHX_compare_hx)( const HHUGEINTX hLeft, const HHUGEINTX hRight );

	/* get property */
	typedef const SIGN (WINAPI* lpfHX_getSign)( const HHUGEINTX hHugeIntX );
	typedef const BOOL (WINAPI* lpfHX_isZero)( const HHUGEINTX hHugeIntX );
	typedef const BOOL (WINAPI* lpfHX_isAbsOne)( const HHUGEINTX hHugeIntX );
	typedef const BOOL (WINAPI* lpfHX_isOdd)( const HHUGEINTX hHugeIntX );
	typedef const BOOL (WINAPI* lpfHX_isEven)( const HHUGEINTX hHugeIntX );
	typedef const BOOL (WINAPI* lpfHX_isBitOne)( const HHUGEINTX hHugeIntX, const UINT32 u32BitIndex );
	typedef const BOOL (WINAPI* lpfHX_isPrime)( const HHUGEINTX hHugeIntX );
	typedef const PRIMALITY (WINAPI* lpfHX_testPrimality)( const HHUGEINTX hHugeIntX, const UINT32 u32Repeat /*= 5*/ );
	typedef const UINT32 (WINAPI* lpfHX_getBits)( const HHUGEINTX hHugeIntX );
	typedef const UINT32 (WINAPI* lpfHX_getDigits)( const HHUGEINTX hHugeIntX );
	typedef const UINT32 (WINAPI* lpfHX_getTailBitZeros)( const HHUGEINTX hHugeIntX );

	typedef HHUGEINTX (WINAPI* lpfHX_bitLShift)( HHUGEINTX hHugeIntX, const UINT32 u32BitLShift );
	typedef HHUGEINTX (WINAPI* lpfHX_bitRShift)( HHUGEINTX hHugeIntX, const UINT32 u32BitRShift );

	typedef HHUGEINTX (WINAPI* lpfHX_bitAnd)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );
	typedef HHUGEINTX (WINAPI* lpfHX_bitXor)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );
	typedef HHUGEINTX (WINAPI* lpfHX_bitOr)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );

	typedef HHUGEINTX (WINAPI* lpfHX_abs)( HHUGEINTX hHugeIntX );
	typedef HHUGEINTX (WINAPI* lpfHX_negate)( HHUGEINTX hHugeIntX );
	typedef HHUGEINTX (WINAPI* lpfHX_swap)( HHUGEINTX hLeft, HHUGEINTX hRight );

	typedef HHUGEINTX (WINAPI* lpfHX_ceil)( HHUGEINTX hHugeIntX, const UINT32 u32Bits );
	typedef HHUGEINTX (WINAPI* lpfHX_truncate)( HHUGEINTX hHugeIntX, const UINT32 u32Bits );
	typedef HHUGEINTX (WINAPI* lpfHX_floor)( HHUGEINTX hHugeIntX, const UINT32 u32Bits );

	typedef HHUGEINTX (WINAPI* lpfHX_random)( HHUGEINTX hHugeIntX, const UINT32 u32Bits );
	typedef HHUGEINTX (WINAPI* lpfHX_generatePrime)( HHUGEINTX hHugeIntX, const UINT32 u32Bits );
	typedef HHUGEINTX (WINAPI* lpfHX_previousPrime)( HHUGEINTX hResult, const HHUGEINTX hBenchmark );
	typedef HHUGEINTX (WINAPI* lpfHX_nextPrime)( HHUGEINTX hResult, const HHUGEINTX hBenchmark );

	/* + */
	typedef HHUGEINTX (WINAPI* lpfHX_add)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );
	typedef HHUGEINTX (WINAPI* lpfHX_add_u32)( HHUGEINTX hResult, const HHUGEINTX hLeft, const UINT32 u32Num );

	/* - */
	typedef HHUGEINTX (WINAPI* lpfHX_sub)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );
	typedef HHUGEINTX (WINAPI* lpfHX_sub_u32)( HHUGEINTX hResult, const HHUGEINTX hLeft, const UINT32 u32Num );

	/* * */
	typedef HHUGEINTX (WINAPI* lpfHX_mul)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );
	typedef HHUGEINTX (WINAPI* lpfHX_mul_u32)( HHUGEINTX hResult, const HHUGEINTX hLeft, const UINT32 u32Num );

	/* Division, return quotient */
	typedef HHUGEINTX (WINAPI* lpfHX_divRem)( HHUGEINTX hQuotient, const HHUGEINTX hDividend, const HHUGEINTX hDivisor, HHUGEINTX hRemainder /*= NULL*/ );
	typedef HHUGEINTX (WINAPI* lpfHX_div_s32)( HHUGEINTX hQuotient, const HHUGEINTX hDividend, const SINT32 s32Divisor, SINT32 * const pRemainder /*= NULL*/ );

	/* % */
	typedef HHUGEINTX (WINAPI* lpfHX_mod)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );

	/* Power */
	typedef HHUGEINTX (WINAPI* lpfHX_pow)( HHUGEINTX hResult, const HHUGEINTX hBase, const UINT32 u32Exp );

	/* Extraction */
	typedef HHUGEINTX (WINAPI* lpfHX_rootRem)( HHUGEINTX hRoot, const HHUGEINTX hRadicand, const UINT32 u32Exp, HHUGEINTX hRemainder /*= NULL*/, BOOL * const pIsReal /*= NULL*/ );

	/* Logarithm */
	typedef const UINT32 (WINAPI* lpfHX_log_u32)( const HHUGEINTX hHugeIntX, const UINT32 u32Base, BOOL * const pIsExact /*= NULL*/ );
	typedef const UINT32 (WINAPI* lpfHX_log)( const HHUGEINTX hHugeIntX, const HHUGEINTX hBase, BOOL * const pIsExact /*= NULL*/ );

	/* PrimeFactorial(n) gives the product of the first n primes. */
	typedef HHUGEINTX (WINAPI* lpfHX_primeFactorial)( HHUGEINTX hResult, const UINT32 u32Index );
	/* Primorial(n) gives the product of the primes less than or equal to n. */
	typedef HHUGEINTX (WINAPI* lpfHX_primorial)( HHUGEINTX hResult, const UINT32 u32Num );

	/* Factorial, Permutation, Combination */
	typedef HHUGEINTX (WINAPI* lpfHX_factorial)( HHUGEINTX hResult, const UINT32 n );
	typedef HHUGEINTX (WINAPI* lpfHX_factorial2)( HHUGEINTX hResult, const UINT32 n );
	typedef HHUGEINTX (WINAPI* lpfHX_permutation)( HHUGEINTX hResult, const UINT32 n, const UINT32 r );
	typedef HHUGEINTX (WINAPI* lpfHX_combination)( HHUGEINTX hResult, const UINT32 n, const UINT32 r );

	/* Fibonacci numbers */
	typedef HHUGEINTX (WINAPI* lpfHX_fibonacci)( HHUGEINTX hResult, const SINT32 n );

	/* Lucas numbers */
	typedef HHUGEINTX (WINAPI* lpfHX_lucas)( HHUGEINTX hResult, const SINT32 n );

	/* MulMod */
	typedef HHUGEINTX (WINAPI* lpfHX_mulMod)( HHUGEINTX hResult, const HHUGEINTX hMultiplicand, const HHUGEINTX hMultiplier, const HHUGEINTX hMod );

	/* InvertMod: x = InvertMod)( b, m ) && !)(!x) <==> )( b * x ) mod m = 1 */
	typedef HHUGEINTX (WINAPI* lpfHX_invertMod_u32)( HHUGEINTX hResult, const UINT32 u32InvertBase, const HHUGEINTX hMod );
	typedef HHUGEINTX (WINAPI* lpfHX_invertMod)( HHUGEINTX hResult, const HHUGEINTX hInvertBase, const HHUGEINTX hMod );

	/* PowMod */
	typedef const UINT32 (WINAPI* lpfHX_powMod_u32_u32)( const UINT32 u32Base, const HHUGEINTX hExp, const UINT32 u32Mod );
	typedef HHUGEINTX (WINAPI* lpfHX_powMod_u32)( HHUGEINTX hResult, const UINT32 u32Base, const HHUGEINTX hExp, const HHUGEINTX hMod );
	typedef HHUGEINTX (WINAPI* lpfHX_powMod)( HHUGEINTX hResult, const HHUGEINTX hBase, const HHUGEINTX hExp, const HHUGEINTX hMod );

	/* ModPowTen: *this %= 2^u32Exp */
	typedef HHUGEINTX (WINAPI* lpfHX_modPowTwo)( HHUGEINTX hHugeIntX, const UINT32 u32Exp );

	/* Greatest Common Divisor */
	typedef HHUGEINTX (WINAPI* lpfHX_gcd)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );
	typedef HHUGEINTX (WINAPI* lpfHX_gcd_vhx)( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector );

	/* GcdEx: g = GcdEx)( x, y, u, v ) = u * x + v * y. g is always positive, even if one or both of u and v are negative. */
	typedef HHUGEINTX (WINAPI* lpfHX_gcdEx)( HHUGEINTX hResult, HHUGEINTX x, HHUGEINTX y, const HHUGEINTX u, const HHUGEINTX v );

	/* Lowest Common Multiple */
	typedef HHUGEINTX (WINAPI* lpfHX_lcm)( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight );
	typedef HHUGEINTX (WINAPI* lpfHX_lcm_v32)( HHUGEINTX hResult, const LPCVECTOR_UINT32 pVector );
	typedef HHUGEINTX (WINAPI* lpfHX_lcm_vhx)( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector );

	typedef HHUGEINTX (WINAPI* lpfHX_product_v32)( HHUGEINTX hResult, const LPCVECTOR_UINT32 pVector );
	typedef HHUGEINTX (WINAPI* lpfHX_product_vhx)( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector );

	/* if u32Exp==0, then call function: Product)( ... ); */
	typedef HHUGEINTX (WINAPI* lpfHX_sumsOfLikePowers_v32)( HHUGEINTX hResult, const LPCVECTOR_UINT32 pVector, const UINT32 u32Exp /*= 1*/ );
	typedef HHUGEINTX (WINAPI* lpfHX_sumsOfLikePowers_vhx)( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector, const UINT32 u32Exp /*= 1*/ );

	/* Output */
	typedef const LPCTSTR (WINAPI* lpfHX_getStr)( const HHUGEINTX hHugeIntX, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ );

	/* no "0x" */
	typedef const LPCTSTR (WINAPI* lpfHX_getHexStr)( const HHUGEINTX hHugeIntX, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ );

	/* This function can convert the huge integer to a string of digits in another Radix system. */
	typedef const LPCTSTR (WINAPI* lpfHX_getStrRadix)( const HHUGEINTX hHugeIntX, const UINT32 u32Radix /*= 10*/, UINT32 * const pDigits /*= NULL*/, const BYTE byFormat /*= FS_DEFAULT*/, const UINT32 u32BandLength /*= 3*/, UINT32 * const pStrLen /*= NULL*/ );

	typedef const LPCTSTR (WINAPI* lpfHX_getText)( const HHUGEINTX hHugeIntX );

	typedef void (WINAPI* lpfHX_freeStrBuffer)( const HHUGEINTX hHugeIntX );
#endif  /* #ifndef _NO_HX */



#ifndef _NO_RC
	typedef HRADIXCONVERTER (WINAPI* lpfRC_new)( const UINT32 u32Radix );
	typedef HRADIXCONVERTER (WINAPI* lpfRC_new_str)( const UINT32 u32Radix, const LPCTSTR lpszNum );
	typedef void (WINAPI* lpfRC_delete)( HRADIXCONVERTER hRadixConverter );

	typedef const UINT32 (WINAPI* lpfRC_getCount)( void );

	typedef HRADIXCONVERTER (WINAPI* lpfRC_convert2Radix)( HRADIXCONVERTER hRadixConverter, const UINT32 u32NewRadix );

	typedef HRADIXCONVERTER (WINAPI* lpfRC_set_rc)( HRADIXCONVERTER hRadixConverter, const HRADIXCONVERTER hRight );

#ifndef _NO_HI
	typedef HRADIXCONVERTER (WINAPI* lpfRC_set_hi)( HRADIXCONVERTER hRadixConverter, const HHUGEINT hRight );
#endif	/* #ifndef _NO_RC */

#ifndef _NO_HX
	typedef HRADIXCONVERTER (WINAPI* lpfRC_set_hx)( HRADIXCONVERTER hRadixConverter, const HHUGEINTX hRight );
#endif	/* #ifndef _NO_HX */

	typedef HRADIXCONVERTER (WINAPI* lpfRC_set_s32)( HRADIXCONVERTER hRadixConverter, const SINT32 s32Num );
	typedef HRADIXCONVERTER (WINAPI* lpfRC_set_s64)( HRADIXCONVERTER hRadixConverter, const SINT64 s64Num );
	typedef HRADIXCONVERTER (WINAPI* lpfRC_set_u32)( HRADIXCONVERTER hRadixConverter, const UINT32 u32Num );
	typedef HRADIXCONVERTER (WINAPI* lpfRC_set_u64)( HRADIXCONVERTER hRadixConverter, const UINT64 u64Num );

	typedef const SINT32 (WINAPI* lpfRC_get_s32)( const HRADIXCONVERTER hRadixConverter );
	typedef const SINT64 (WINAPI* lpfRC_get_s64)( const HRADIXCONVERTER hRadixConverter );
	typedef const UINT32 (WINAPI* lpfRC_get_u32)( const HRADIXCONVERTER hRadixConverter );
	typedef const UINT64 (WINAPI* lpfRC_get_u64)( const HRADIXCONVERTER hRadixConverter );

	typedef void (WINAPI* lpfRC_resetRadix)( HRADIXCONVERTER hRadixConverter, const UINT32 u32Radix );
	typedef void (WINAPI* lpfRC_resetSign)( HRADIXCONVERTER hRadixConverter, const SIGN enumSign );
	typedef void (WINAPI* lpfRC_resetVector)( HRADIXCONVERTER hRadixConverter, const LPCVECTOR_UINT32 pVector );
	typedef void (WINAPI* lpfRC_clearVector)( HRADIXCONVERTER hRadixConverter );

	typedef const UINT32 (WINAPI* lpfRC_getRadix)( const HRADIXCONVERTER hRadixConverter );
	typedef const SIGN (WINAPI* lpfRC_getSign)( const HRADIXCONVERTER hRadixConverter );
	typedef const LPCVECTOR_UINT32 (WINAPI* lpfRC_getVector)( const HRADIXCONVERTER hRadixConverter, const PCVECTOR_UINT32 pVector );
	typedef const UINT64 (WINAPI* lpfRC_sumOfDigits)( const HRADIXCONVERTER hRadixConverter );
#endif	/* #ifndef _NO_RC */



	#define	_HC_getVer                      ( *( (lpfHC_getVer)                     s_pfFun[ fnHC_getVer ]                  ) )

	#define	_HC_getSN                       ( *( (lpfHC_getSN)                      s_pfFun[ fnHC_getSN ]                   ) )

	#define	_HC_getExportFunNums            ( *( (lpfHC_getExportFunNums)           s_pfFun[ fnHC_getExportFunNums ]        ) )
	#define	_HC_getLicenseLevel             ( *( (lpfHC_getLicenseLevel)            s_pfFun[ fnHC_getLicenseLevel ]         ) )

	#define	_HC_getLastError                ( *( (lpfHC_getLastError)               s_pfFun[ fnHC_getLastError ]            ) )

	#define	_HC_setTerminate                ( *( (lpfHC_setTerminate)               s_pfFun[ fnHC_setTerminate ]            ) )
	#define	_HC_isTerminated                ( *( (lpfHC_isTerminated)               s_pfFun[ fnHC_isTerminated ]            ) )

	#define	_HC_seedRandom                  ( *( (lpfHC_seedRandom)                 s_pfFun[ fnHC_seedRandom ]              ) )

	#define	_HC_resetTimer                  ( *( (lpfHC_resetTimer)                 s_pfFun[ fnHC_resetTimer ]              ) )
	#define	_HC_enableTimer                 ( *( (lpfHC_enableTimer)                s_pfFun[ fnHC_enableTimer ]             ) )
	#define	_HC_getTimer                    ( *( (lpfHC_getTimer)                   s_pfFun[ fnHC_getTimer ]                ) )
	#define	_HC_getTimerStr                 ( *( (lpfHC_getTimerStr)                s_pfFun[ fnHC_getTimerStr ]             ) )

	#define	_HC_isPrime                     ( *( (lpfHC_isPrime)                    s_pfFun[ fnHC_isPrime ]                 ) )
	#define	_HC_getPrimePi                  ( *( (lpfHC_getPrimePi)                 s_pfFun[ fnHC_getPrimePi ]              ) )
	#define	_HC_getPrime                    ( *( (lpfHC_getPrime)                   s_pfFun[ fnHC_getPrime ]                ) )
	#define	_HC_previousPrime               ( *( (lpfHC_previousPrime)              s_pfFun[ fnHC_previousPrime ]           ) )
	#define	_HC_nextPrime                   ( *( (lpfHC_nextPrime)                  s_pfFun[ fnHC_nextPrime ]               ) )
	#define	_HC_getPrimeCount               ( *( (lpfHC_getPrimeCount)              s_pfFun[ fnHC_getPrimeCount ]           ) )
	#define	_HC_getPrimeList                ( *( (lpfHC_getPrimeList)               s_pfFun[ fnHC_getPrimeList ]            ) )

	#define	_HC_EulerPhi                    ( *( (lpfHC_EulerPhi)                   s_pfFun[ fnHC_EulerPhi ]                ) )
	#define	_HC_JacobiSymbol                ( *( (lpfHC_JacobiSymbol)               s_pfFun[ fnHC_JacobiSymbol ]            ) )
	#define	_HC_MultiplicativeOrder         ( *( (lpfHC_MultiplicativeOrder)        s_pfFun[ fnHC_MultiplicativeOrder ]     ) )
	#define	_HC_PrimitiveRoot               ( *( (lpfHC_PrimitiveRoot)              s_pfFun[ fnHC_PrimitiveRoot ]           ) )


	#define	_HC_gcd                         ( *( (lpfHC_gcd)                        s_pfFun[ fnHC_gcd ]                     ) )
	#define	_HC_gcd_v32                     ( *( (lpfHC_gcd_v32)                    s_pfFun[ fnHC_gcd_v32 ]                 ) )
	#define	_HC_gcdEx                       ( *( (lpfHC_gcdEx)                      s_pfFun[ fnHC_gcdEx ]                   ) )
	#define	_HC_invertMod                   ( *( (lpfHC_invertMod)                  s_pfFun[ fnHC_invertMod ]               ) )
	#define	_HC_lcm                         ( *( (lpfHC_lcm)                        s_pfFun[ fnHC_lcm ]                     ) )
	#define	_HC_powMod                      ( *( (lpfHC_powMod)                     s_pfFun[ fnHC_powMod ]                  ) )



	#ifndef _NO_HI
	#define	_HI_abs                         ( *( (lpfHI_abs)                        s_pfFun[ fnHI_abs ]                     ) )
	#define	_HI_add                         ( *( (lpfHI_add)                        s_pfFun[ fnHI_add ]                     ) )
	#define	_HI_add_u32                     ( *( (lpfHI_add_u32)                    s_pfFun[ fnHI_add_u32 ]                 ) )
	#define	_HI_bitAnd                      ( *( (lpfHI_bitAnd)                     s_pfFun[ fnHI_bitAnd ]                  ) )
	#define	_HI_bitLShift                   ( *( (lpfHI_bitLShift)                  s_pfFun[ fnHI_bitLShift ]               ) )
	#define	_HI_bitRShift                   ( *( (lpfHI_bitRShift)                  s_pfFun[ fnHI_bitRShift ]               ) )
	#define	_HI_bitOr                       ( *( (lpfHI_bitOr)                      s_pfFun[ fnHI_bitOr ]                   ) )
	#define	_HI_bitXor                      ( *( (lpfHI_bitXor)                     s_pfFun[ fnHI_bitXor ]                  ) )
	#define	_HI_ceil                        ( *( (lpfHI_ceil)                       s_pfFun[ fnHI_ceil ]                    ) )
	#define	_HI_combination                 ( *( (lpfHI_combination)                s_pfFun[ fnHI_combination ]             ) )
	#define	_HI_compareAbs_hi               ( *( (lpfHI_compareAbs_hi)              s_pfFun[ fnHI_compareAbs_hi ]           ) )
	#define	_HI_compareAbs_s32              ( *( (lpfHI_compareAbs_s32)             s_pfFun[ fnHI_compareAbs_s32 ]          ) )
	#define	_HI_compareAbs_u32              ( *( (lpfHI_compareAbs_u32)             s_pfFun[ fnHI_compareAbs_u32 ]          ) )
	#define	_HI_compare_hi                  ( *( (lpfHI_compare_hi)                 s_pfFun[ fnHI_compare_hi ]              ) )
	#define	_HI_compare_s32                 ( *( (lpfHI_compare_s32)                s_pfFun[ fnHI_compare_s32 ]             ) )
	#define	_HI_compare_u32                 ( *( (lpfHI_compare_u32)                s_pfFun[ fnHI_compare_u32 ]             ) )
	#define	_HI_decLShift                   ( *( (lpfHI_decLShift)                  s_pfFun[ fnHI_decLShift ]               ) )
	#define	_HI_decRShift                   ( *( (lpfHI_decRShift)                  s_pfFun[ fnHI_decRShift ]               ) )
	#define	_HI_delete                      ( *( (lpfHI_delete)                     s_pfFun[ fnHI_delete ]                  ) )
	#define	_HI_divRem                      ( *( (lpfHI_divRem)                     s_pfFun[ fnHI_divRem ]                  ) )
	#define	_HI_div_s32                     ( *( (lpfHI_div_s32)                    s_pfFun[ fnHI_div_s32 ]                 ) )
	#define	_HI_factorial                   ( *( (lpfHI_factorial)                  s_pfFun[ fnHI_factorial ]               ) )
	#define	_HI_factorial2                  ( *( (lpfHI_factorial2)                 s_pfFun[ fnHI_factorial2 ]              ) )
	#define	_HI_fibonacci                   ( *( (lpfHI_fibonacci)                  s_pfFun[ fnHI_fibonacci ]               ) )
	#define	_HI_floor                       ( *( (lpfHI_floor)                      s_pfFun[ fnHI_floor ]                   ) )
	#define	_HI_freeStrBuffer               ( *( (lpfHI_freeStrBuffer)              s_pfFun[ fnHI_freeStrBuffer ]           ) )
	#define	_HI_gcd                         ( *( (lpfHI_gcd)                        s_pfFun[ fnHI_gcd ]                     ) )
	#define	_HI_gcdEx                       ( *( (lpfHI_gcdEx)                      s_pfFun[ fnHI_gcdEx ]                   ) )
	#define	_HI_gcd_vhi                     ( *( (lpfHI_gcd_vhi)                    s_pfFun[ fnHI_gcd_vhi ]                 ) )
	#define	_HI_generatePrime               ( *( (lpfHI_generatePrime)              s_pfFun[ fnHI_generatePrime ]           ) )
	#define	_HI_getBits                     ( *( (lpfHI_getBits)                    s_pfFun[ fnHI_getBits ]                 ) )
	#define	_HI_getCount                    ( *( (lpfHI_getCount)                   s_pfFun[ fnHI_getCount ]                ) )
	#define	_HI_getDigits                   ( *( (lpfHI_getDigits)                  s_pfFun[ fnHI_getDigits ]               ) )
	#define	_HI_getHexStr                   ( *( (lpfHI_getHexStr)                  s_pfFun[ fnHI_getHexStr ]               ) )
	#define	_HI_getSign                     ( *( (lpfHI_getSign)                    s_pfFun[ fnHI_getSign ]                 ) )
	#define	_HI_getStr                      ( *( (lpfHI_getStr)                     s_pfFun[ fnHI_getStr ]                  ) )
	#define	_HI_getStrRadix                 ( *( (lpfHI_getStrRadix)                s_pfFun[ fnHI_getStrRadix ]             ) )
	#define	_HI_getTailDecZeros             ( *( (lpfHI_getTailDecZeros)            s_pfFun[ fnHI_getTailDecZeros ]         ) )
	#define	_HI_get_s32                     ( *( (lpfHI_get_s32)                    s_pfFun[ fnHI_get_s32 ]                 ) )
	#define	_HI_get_s64                     ( *( (lpfHI_get_s64)                    s_pfFun[ fnHI_get_s64 ]                 ) )
	#define	_HI_get_u32                     ( *( (lpfHI_get_u32)                    s_pfFun[ fnHI_get_u32 ]                 ) )
	#define	_HI_get_u64                     ( *( (lpfHI_get_u64)                    s_pfFun[ fnHI_get_u64 ]                 ) )
	#define	_HI_invertMod                   ( *( (lpfHI_invertMod)                  s_pfFun[ fnHI_invertMod ]               ) )
	#define	_HI_invertMod_u32               ( *( (lpfHI_invertMod_u32)              s_pfFun[ fnHI_invertMod_u32 ]           ) )
	#define	_HI_isAbsOne                    ( *( (lpfHI_isAbsOne)                   s_pfFun[ fnHI_isAbsOne ]                ) )
	#define	_HI_isEven                      ( *( (lpfHI_isEven)                     s_pfFun[ fnHI_isEven ]                  ) )
	#define	_HI_isOdd                       ( *( (lpfHI_isOdd)                      s_pfFun[ fnHI_isOdd ]                   ) )
	#define	_HI_isPrime                     ( *( (lpfHI_isPrime)                    s_pfFun[ fnHI_isPrime ]                 ) )
	#define	_HI_isZero                      ( *( (lpfHI_isZero)                     s_pfFun[ fnHI_isZero ]                  ) )
	#define	_HI_lcm                         ( *( (lpfHI_lcm)                        s_pfFun[ fnHI_lcm ]                     ) )
	#define	_HI_lcm_v32                     ( *( (lpfHI_lcm_v32)                    s_pfFun[ fnHI_lcm_v32 ]                 ) )
	#define	_HI_lcm_vhi                     ( *( (lpfHI_lcm_vhi)                    s_pfFun[ fnHI_lcm_vhi ]                 ) )
	#define	_HI_log                         ( *( (lpfHI_log)                        s_pfFun[ fnHI_log ]                     ) )
	#define	_HI_log_u32                     ( *( (lpfHI_log_u32)                    s_pfFun[ fnHI_log_u32 ]                 ) )
	#define	_HI_lucas                       ( *( (lpfHI_lucas)                      s_pfFun[ fnHI_lucas ]                   ) )
	#define	_HI_mod                         ( *( (lpfHI_mod)                        s_pfFun[ fnHI_mod ]                     ) )
	#define	_HI_modPowTen                   ( *( (lpfHI_modPowTen)                  s_pfFun[ fnHI_modPowTen ]               ) )
	#define	_HI_mul                         ( *( (lpfHI_mul)                        s_pfFun[ fnHI_mul ]                     ) )
	#define	_HI_mulMod                      ( *( (lpfHI_mulMod)                     s_pfFun[ fnHI_mulMod ]                  ) )
	#define	_HI_mul_u32                     ( *( (lpfHI_mul_u32)                    s_pfFun[ fnHI_mul_u32 ]                 ) )
	#define	_HI_negate                      ( *( (lpfHI_negate)                     s_pfFun[ fnHI_negate ]                  ) )
	#define	_HI_new                         ( *( (lpfHI_new)                        s_pfFun[ fnHI_new ]                     ) )
	#define	_HI_nextPrime                   ( *( (lpfHI_nextPrime)                  s_pfFun[ fnHI_nextPrime ]               ) )
	#define	_HI_permutation                 ( *( (lpfHI_permutation)                s_pfFun[ fnHI_permutation ]             ) )
	#define	_HI_pow                         ( *( (lpfHI_pow)                        s_pfFun[ fnHI_pow ]                     ) )
	#define	_HI_powMod                      ( *( (lpfHI_powMod)                     s_pfFun[ fnHI_powMod ]                  ) )
	#define	_HI_powMod_u32                  ( *( (lpfHI_powMod_u32)                 s_pfFun[ fnHI_powMod_u32 ]              ) )
	#define	_HI_powMod_u32_u32              ( *( (lpfHI_powMod_u32_u32)             s_pfFun[ fnHI_powMod_u32_u32 ]          ) )
	#define	_HI_previousPrime               ( *( (lpfHI_previousPrime)              s_pfFun[ fnHI_previousPrime ]           ) )
	#define	_HI_primeFactorial              ( *( (lpfHI_primeFactorial)             s_pfFun[ fnHI_primeFactorial ]          ) )
	#define	_HI_primorial                   ( *( (lpfHI_primorial)                  s_pfFun[ fnHI_primorial ]               ) )
	#define	_HI_product_v32                 ( *( (lpfHI_product_v32)                s_pfFun[ fnHI_product_v32 ]             ) )
	#define	_HI_product_vhi                 ( *( (lpfHI_product_vhi)                s_pfFun[ fnHI_product_vhi ]             ) )
	#define	_HI_random                      ( *( (lpfHI_random)                     s_pfFun[ fnHI_random ]                  ) )
	#define	_HI_rootRem                     ( *( (lpfHI_rootRem)                    s_pfFun[ fnHI_rootRem ]                 ) )
	#define	_HI_setHexStr                   ( *( (lpfHI_setHexStr)                  s_pfFun[ fnHI_setHexStr ]               ) )
	#define	_HI_set_hi                      ( *( (lpfHI_set_hi)                     s_pfFun[ fnHI_set_hi ]                  ) )

#ifndef _NO_HX
	#define	_HI_set_hx                      ( *( (lpfHI_set_hx)                     s_pfFun[ fnHI_set_hx ]                  ) )
#endif	/* #ifndef _NO_HX */

#ifndef _NO_RC
	#define	_HI_set_rc                      ( *( (lpfHI_set_rc)                     s_pfFun[ fnHI_set_rc ]                  ) )
#endif	/* #ifndef _NO_RC */

	#define	_HI_set_s32                     ( *( (lpfHI_set_s32)                    s_pfFun[ fnHI_set_s32 ]                 ) )
	#define	_HI_set_s64                     ( *( (lpfHI_set_s64)                    s_pfFun[ fnHI_set_s64 ]                 ) )
	#define	_HI_set_str                     ( *( (lpfHI_set_str)                    s_pfFun[ fnHI_set_str ]                 ) )
	#define	_HI_set_u32                     ( *( (lpfHI_set_u32)                    s_pfFun[ fnHI_set_u32 ]                 ) )
	#define	_HI_set_u64                     ( *( (lpfHI_set_u64)                    s_pfFun[ fnHI_set_u64 ]                 ) )
	#define	_HI_sub                         ( *( (lpfHI_sub)                        s_pfFun[ fnHI_sub ]                     ) )
	#define	_HI_sub_u32                     ( *( (lpfHI_sub_u32)                    s_pfFun[ fnHI_sub_u32 ]                 ) )
	#define	_HI_sumsOfLikePowers_v32        ( *( (lpfHI_sumsOfLikePowers_v32)       s_pfFun[ fnHI_sumsOfLikePowers_v32 ]    ) )
	#define	_HI_sumsOfLikePowers_vhi        ( *( (lpfHI_sumsOfLikePowers_vhi)       s_pfFun[ fnHI_sumsOfLikePowers_vhi ]    ) )
	#define	_HI_swap                        ( *( (lpfHI_swap)                       s_pfFun[ fnHI_swap ]                    ) )
	#define	_HI_testPrimality               ( *( (lpfHI_testPrimality)              s_pfFun[ fnHI_testPrimality ]           ) )
	#define	_HI_truncate                    ( *( (lpfHI_truncate)                   s_pfFun[ fnHI_truncate ]                ) )
#endif	/* #ifndef _NO_HI */



#ifndef _NO_HX
	#define	_HX_abs                         ( *( (lpfHX_abs)                        s_pfFun[ fnHX_abs ]                     ) )
	#define	_HX_add                         ( *( (lpfHX_add)                        s_pfFun[ fnHX_add ]                     ) )
	#define	_HX_add_u32                     ( *( (lpfHX_add_u32)                    s_pfFun[ fnHX_add_u32 ]                 ) )
	#define	_HX_bitAnd                      ( *( (lpfHX_bitAnd)                     s_pfFun[ fnHX_bitAnd ]                  ) )
	#define	_HX_bitLShift                   ( *( (lpfHX_bitLShift)                  s_pfFun[ fnHX_bitLShift ]               ) )
	#define	_HX_bitRShift                   ( *( (lpfHX_bitRShift)                  s_pfFun[ fnHX_bitRShift ]               ) )
	#define	_HX_bitOr                       ( *( (lpfHX_bitOr)                      s_pfFun[ fnHX_bitOr ]                   ) )
	#define	_HX_bitXor                      ( *( (lpfHX_bitXor)                     s_pfFun[ fnHX_bitXor ]                  ) )
	#define	_HX_ceil                        ( *( (lpfHX_ceil)                       s_pfFun[ fnHX_ceil ]                    ) )
	#define	_HX_combination                 ( *( (lpfHX_combination)                s_pfFun[ fnHX_combination ]             ) )
	#define	_HX_compareAbs_hx               ( *( (lpfHX_compareAbs_hx)              s_pfFun[ fnHX_compareAbs_hx ]           ) )
	#define	_HX_compareAbs_s32              ( *( (lpfHX_compareAbs_s32)             s_pfFun[ fnHX_compareAbs_s32 ]          ) )
	#define	_HX_compareAbs_u32              ( *( (lpfHX_compareAbs_u32)             s_pfFun[ fnHX_compareAbs_u32 ]          ) )
	#define	_HX_compare_hx                  ( *( (lpfHX_compare_hx)                 s_pfFun[ fnHX_compare_hx ]              ) )
	#define	_HX_compare_s32                 ( *( (lpfHX_compare_s32)                s_pfFun[ fnHX_compare_s32 ]             ) )
	#define	_HX_compare_u32                 ( *( (lpfHX_compare_u32)                s_pfFun[ fnHX_compare_u32 ]             ) )
	#define	_HX_delete                      ( *( (lpfHX_delete)                     s_pfFun[ fnHX_delete ]                  ) )
	#define	_HX_divRem                      ( *( (lpfHX_divRem)                     s_pfFun[ fnHX_divRem ]                  ) )
	#define	_HX_div_s32                     ( *( (lpfHX_div_s32)                    s_pfFun[ fnHX_div_s32 ]                 ) )
	#define	_HX_factorial                   ( *( (lpfHX_factorial)                  s_pfFun[ fnHX_factorial ]               ) )
	#define	_HX_factorial2                  ( *( (lpfHX_factorial2)                 s_pfFun[ fnHX_factorial2 ]              ) )
	#define	_HX_fibonacci                   ( *( (lpfHX_fibonacci)                  s_pfFun[ fnHX_fibonacci ]               ) )
	#define	_HX_floor                       ( *( (lpfHX_floor)                      s_pfFun[ fnHX_floor ]                   ) )
	#define	_HX_freeStrBuffer               ( *( (lpfHX_freeStrBuffer)              s_pfFun[ fnHX_freeStrBuffer ]           ) )
	#define	_HX_gcd                         ( *( (lpfHX_gcd)                        s_pfFun[ fnHX_gcd ]                     ) )
	#define	_HX_gcdEx                       ( *( (lpfHX_gcdEx)                      s_pfFun[ fnHX_gcdEx ]                   ) )
	#define	_HX_gcd_vhx                     ( *( (lpfHX_gcd_vhx)                    s_pfFun[ fnHX_gcd_vhx ]                 ) )
	#define	_HX_generatePrime               ( *( (lpfHX_generatePrime)              s_pfFun[ fnHX_generatePrime ]           ) )
	#define	_HX_getBits                     ( *( (lpfHX_getBits)                    s_pfFun[ fnHX_getBits ]                 ) )
	#define	_HX_getCount                    ( *( (lpfHX_getCount)                   s_pfFun[ fnHX_getCount ]                ) )
	#define	_HX_getDigits                   ( *( (lpfHX_getDigits)                  s_pfFun[ fnHX_getDigits ]               ) )
	#define	_HX_getHexStr                   ( *( (lpfHX_getHexStr)                  s_pfFun[ fnHX_getHexStr ]               ) )
	#define	_HX_getSign                     ( *( (lpfHX_getSign)                    s_pfFun[ fnHX_getSign ]                 ) )
	#define	_HX_getStr                      ( *( (lpfHX_getStr)                     s_pfFun[ fnHX_getStr ]                  ) )
	#define	_HX_getStrRadix                 ( *( (lpfHX_getStrRadix)                s_pfFun[ fnHX_getStrRadix ]             ) )
	#define	_HX_getTailBitZeros             ( *( (lpfHX_getTailBitZeros)            s_pfFun[ fnHX_getTailBitZeros ]         ) )
	#define	_HX_getText                     ( *( (lpfHX_getText)                    s_pfFun[ fnHX_getText ]                 ) )
	#define	_HX_get_s32                     ( *( (lpfHX_get_s32)                    s_pfFun[ fnHX_get_s32 ]                 ) )
	#define	_HX_get_s64                     ( *( (lpfHX_get_s64)                    s_pfFun[ fnHX_get_s64 ]                 ) )
	#define	_HX_get_u32                     ( *( (lpfHX_get_u32)                    s_pfFun[ fnHX_get_u32 ]                 ) )
	#define	_HX_get_u64                     ( *( (lpfHX_get_u64)                    s_pfFun[ fnHX_get_u64 ]                 ) )
	#define	_HX_invertMod                   ( *( (lpfHX_invertMod)                  s_pfFun[ fnHX_invertMod ]               ) )
	#define	_HX_invertMod_u32               ( *( (lpfHX_invertMod_u32)              s_pfFun[ fnHX_invertMod_u32 ]           ) )
	#define	_HX_isAbsOne                    ( *( (lpfHX_isAbsOne)                   s_pfFun[ fnHX_isAbsOne ]                ) )
	#define	_HX_isBitOne                    ( *( (lpfHX_isBitOne)                   s_pfFun[ fnHX_isBitOne ]                ) )
	#define	_HX_isEven                      ( *( (lpfHX_isEven)                     s_pfFun[ fnHX_isEven ]                  ) )
	#define	_HX_isOdd                       ( *( (lpfHX_isOdd)                      s_pfFun[ fnHX_isOdd ]                   ) )
	#define	_HX_isPrime                     ( *( (lpfHX_isPrime)                    s_pfFun[ fnHX_isPrime ]                 ) )
	#define	_HX_isZero                      ( *( (lpfHX_isZero)                     s_pfFun[ fnHX_isZero ]                  ) )
	#define	_HX_lcm                         ( *( (lpfHX_lcm)                        s_pfFun[ fnHX_lcm ]                     ) )
	#define	_HX_lcm_v32                     ( *( (lpfHX_lcm_v32)                    s_pfFun[ fnHX_lcm_v32 ]                 ) )
	#define	_HX_lcm_vhx                     ( *( (lpfHX_lcm_vhx)                    s_pfFun[ fnHX_lcm_vhx ]                 ) )
	#define	_HX_log                         ( *( (lpfHX_log)                        s_pfFun[ fnHX_log ]                     ) )
	#define	_HX_log_u32                     ( *( (lpfHX_log_u32)                    s_pfFun[ fnHX_log_u32 ]                 ) )
	#define	_HX_lucas                       ( *( (lpfHX_lucas)                      s_pfFun[ fnHX_lucas ]                   ) )
	#define	_HX_mod                         ( *( (lpfHX_mod)                        s_pfFun[ fnHX_mod ]                     ) )
	#define	_HX_modPowTwo                   ( *( (lpfHX_modPowTwo)                  s_pfFun[ fnHX_modPowTwo ]               ) )
	#define	_HX_mul                         ( *( (lpfHX_mul)                        s_pfFun[ fnHX_mul ]                     ) )
	#define	_HX_mulMod                      ( *( (lpfHX_mulMod)                     s_pfFun[ fnHX_mulMod ]                  ) )
	#define	_HX_mul_u32                     ( *( (lpfHX_mul_u32)                    s_pfFun[ fnHX_mul_u32 ]                 ) )
	#define	_HX_negate                      ( *( (lpfHX_negate)                     s_pfFun[ fnHX_negate ]                  ) )
	#define	_HX_new                         ( *( (lpfHX_new)                        s_pfFun[ fnHX_new ]                     ) )
	#define	_HX_nextPrime                   ( *( (lpfHX_nextPrime)                  s_pfFun[ fnHX_nextPrime ]               ) )
	#define	_HX_permutation                 ( *( (lpfHX_permutation)                s_pfFun[ fnHX_permutation ]             ) )
	#define	_HX_pow                         ( *( (lpfHX_pow)                        s_pfFun[ fnHX_pow ]                     ) )
	#define	_HX_powMod                      ( *( (lpfHX_powMod)                     s_pfFun[ fnHX_powMod ]                  ) )
	#define	_HX_powMod_u32                  ( *( (lpfHX_powMod_u32)                 s_pfFun[ fnHX_powMod_u32 ]              ) )
	#define	_HX_powMod_u32_u32              ( *( (lpfHX_powMod_u32_u32)             s_pfFun[ fnHX_powMod_u32_u32 ]          ) )
	#define	_HX_previousPrime               ( *( (lpfHX_previousPrime)              s_pfFun[ fnHX_previousPrime ]           ) )
	#define	_HX_primeFactorial              ( *( (lpfHX_primeFactorial)             s_pfFun[ fnHX_primeFactorial ]          ) )
	#define	_HX_primorial                   ( *( (lpfHX_primorial)                  s_pfFun[ fnHX_primorial ]               ) )
	#define	_HX_product_v32                 ( *( (lpfHX_product_v32)                s_pfFun[ fnHX_product_v32 ]             ) )
	#define	_HX_product_vhx                 ( *( (lpfHX_product_vhx)                s_pfFun[ fnHX_product_vhx ]             ) )
	#define	_HX_random                      ( *( (lpfHX_random)                     s_pfFun[ fnHX_random ]                  ) )
	#define	_HX_rootRem                     ( *( (lpfHX_rootRem)                    s_pfFun[ fnHX_rootRem ]                 ) )
	#define	_HX_setHexStr                   ( *( (lpfHX_setHexStr)                  s_pfFun[ fnHX_setHexStr ]               ) )
	#define	_HX_setText                     ( *( (lpfHX_setText)                    s_pfFun[ fnHX_setText ]                 ) )

#ifndef _NO_HI
	#define	_HX_set_hi                      ( *( (lpfHX_set_hi)                     s_pfFun[ fnHX_set_hi ]                  ) )
#endif	/* #ifndef _NO_HI */

	#define	_HX_set_hx                      ( *( (lpfHX_set_hx)                     s_pfFun[ fnHX_set_hx ]                  ) )

#ifndef _NO_RC
	#define	_HX_set_rc                      ( *( (lpfHX_set_rc)                     s_pfFun[ fnHX_set_rc ]                  ) )
#endif	/* #ifndef _NO_RC */

	#define	_HX_set_s32                     ( *( (lpfHX_set_s32)                    s_pfFun[ fnHX_set_s32 ]                 ) )
	#define	_HX_set_s64                     ( *( (lpfHX_set_s64)                    s_pfFun[ fnHX_set_s64 ]                 ) )
	#define	_HX_set_str                     ( *( (lpfHX_set_str)                    s_pfFun[ fnHX_set_str ]                 ) )
	#define	_HX_set_u32                     ( *( (lpfHX_set_u32)                    s_pfFun[ fnHX_set_u32 ]                 ) )
	#define	_HX_set_u64                     ( *( (lpfHX_set_u64)                    s_pfFun[ fnHX_set_u64 ]                 ) )
	#define	_HX_sub                         ( *( (lpfHX_sub)                        s_pfFun[ fnHX_sub ]                     ) )
	#define	_HX_sub_u32                     ( *( (lpfHX_sub_u32)                    s_pfFun[ fnHX_sub_u32 ]                 ) )
	#define	_HX_sumsOfLikePowers_v32        ( *( (lpfHX_sumsOfLikePowers_v32)       s_pfFun[ fnHX_sumsOfLikePowers_v32 ]    ) )
	#define	_HX_sumsOfLikePowers_vhx        ( *( (lpfHX_sumsOfLikePowers_vhx)       s_pfFun[ fnHX_sumsOfLikePowers_vhx ]    ) )
	#define	_HX_swap                        ( *( (lpfHX_swap)                       s_pfFun[ fnHX_swap ]                    ) )
	#define	_HX_testPrimality               ( *( (lpfHX_testPrimality)              s_pfFun[ fnHX_testPrimality ]           ) )
	#define	_HX_truncate                    ( *( (lpfHX_truncate)                   s_pfFun[ fnHX_truncate ]                ) )
#endif  /* #ifndef _NO_HX */



#ifndef _NO_RC
	#define	_RC_clearVector                 ( *( (lpfRC_clearVector)                s_pfFun[ fnRC_clearVector ]             ) )
	#define	_RC_convert2Radix               ( *( (lpfRC_convert2Radix)              s_pfFun[ fnRC_convert2Radix ]           ) )
	#define	_RC_delete                      ( *( (lpfRC_delete)                     s_pfFun[ fnRC_delete ]                  ) )
	#define	_RC_getRadix                    ( *( (lpfRC_getRadix)                   s_pfFun[ fnRC_getRadix ]                ) )
	#define	_RC_getCount                    ( *( (lpfRC_getCount)                   s_pfFun[ fnRC_getCount ]                ) )
	#define	_RC_getSign                     ( *( (lpfRC_getSign)                    s_pfFun[ fnRC_getSign ]                 ) )
	#define	_RC_getVector                   ( *( (lpfRC_getVector)                  s_pfFun[ fnRC_getVector ]               ) )
	#define	_RC_get_s32                     ( *( (lpfRC_get_s32)                    s_pfFun[ fnRC_get_s32 ]                 ) )
	#define	_RC_get_s64                     ( *( (lpfRC_get_s64)                    s_pfFun[ fnRC_get_s64 ]                 ) )
	#define	_RC_get_u32                     ( *( (lpfRC_get_u32)                    s_pfFun[ fnRC_get_u32 ]                 ) )
	#define	_RC_get_u64                     ( *( (lpfRC_get_u64)                    s_pfFun[ fnRC_get_u64 ]                 ) )
	#define	_RC_new                         ( *( (lpfRC_new)                        s_pfFun[ fnRC_new ]                     ) )
	#define	_RC_new_str                     ( *( (lpfRC_new_str)                    s_pfFun[ fnRC_new_str ]                 ) )
	#define	_RC_resetRadix                  ( *( (lpfRC_resetRadix)                 s_pfFun[ fnRC_resetRadix ]              ) )
	#define	_RC_resetSign                   ( *( (lpfRC_resetSign)                  s_pfFun[ fnRC_resetSign ]               ) )
	#define	_RC_resetVector                 ( *( (lpfRC_resetVector)                s_pfFun[ fnRC_resetVector ]             ) )

#ifndef _NO_HI
	#define	_RC_set_hi                      ( *( (lpfRC_set_hi)                     s_pfFun[ fnRC_set_hi ]                  ) )
#endif	/* #ifndef _NO_RC */

#ifndef _NO_HX
	#define	_RC_set_hx                      ( *( (lpfRC_set_hx)                     s_pfFun[ fnRC_set_hx ]                  ) )
#endif	/* #ifndef _NO_HX */

	#define	_RC_set_rc                      ( *( (lpfRC_set_rc)                     s_pfFun[ fnRC_set_rc ]                  ) )
	#define	_RC_set_s32                     ( *( (lpfRC_set_s32)                    s_pfFun[ fnRC_set_s32 ]                 ) )
	#define	_RC_set_s64                     ( *( (lpfRC_set_s64)                    s_pfFun[ fnRC_set_s64 ]                 ) )
	#define	_RC_set_u32                     ( *( (lpfRC_set_u32)                    s_pfFun[ fnRC_set_u32 ]                 ) )
	#define	_RC_set_u64                     ( *( (lpfRC_set_u64)                    s_pfFun[ fnRC_set_u64 ]                 ) )
	#define	_RC_sumOfDigits                 ( *( (lpfRC_sumOfDigits)                s_pfFun[ fnRC_sumOfDigits ]             ) )
#endif	/* #ifndef _NO_RC */



const LPCTSTR HC_getVer( void )
{
	return _HC_getVer();
}

const LPCTSTR HC_getSN( void )
{
	return _HC_getSN();
}

const HCLicenseLevel HC_getLicenseLevel( void )
{
	return _HC_getLicenseLevel();
}

const UINT32 HC_getExportFunNums( const UINT32 u32Mask /*= _HC_Export_ANSI_C*/ )
{
	return _HC_getExportFunNums( u32Mask );
}

const HCErrCode HC_getLastError( void )
{
	return _HC_getLastError();
}

/* It usefull when use multithread. */
void HC_setTerminate( const BOOL bTerminate /*= TRUE*/ )
{
	_HC_setTerminate( bTerminate );
}

const BOOL HC_isTerminated( void )
{
	return _HC_isTerminated();
}

void HC_seedRandom( const UINT32 u32Seed /*= 0*/ )
{
	_HC_seedRandom( u32Seed );
}

/* before calculate, pls call bEnableTimer as TRUE, and after finishing call as FALSE */
void HC_resetTimer( const UINT32 u32Timer /*= 0*/, const TimerUnit enumTimerUnit /*= TIMER_UNIT_us*/ )
{
	_HC_resetTimer( u32Timer, enumTimerUnit );
}

void HC_enableTimer( const BOOL bEnableTimer /*= TRUE*/ )
{
	_HC_enableTimer( bEnableTimer );
}

const UINT32 HC_getTimer( const TimerUnit enumTimerUnit /*= TIMER_UNIT_us*/ )
{
	return _HC_getTimer( enumTimerUnit );
}

const LPCTSTR HC_getTimerStr( const FormatTime enumFormatTime /*= FT_DOT06SEC_s*/ )
{
	return _HC_getTimerStr( enumFormatTime );
}

const BOOL HC_isPrime( const UINT32 u32Num )
{
	return _HC_isPrime( u32Num );
}

const UINT32 HC_getPrimePi( const UINT32 u32Num )
{
	return _HC_getPrimePi( u32Num );
}

const UINT32 HC_getPrime( const UINT32 u32Index )
{
	return _HC_getPrime( u32Index );
}

/* Returns the largest prime number less than the argument. */
const SINT32 HC_previousPrime( const SINT32 s32Benchmark )
{
	return _HC_previousPrime( s32Benchmark );
}

/* Returns the smallest prime number greater than the argument. */
const SINT32 HC_nextPrime( const SINT32 s32Benchmark )
{
	return _HC_nextPrime( s32Benchmark );
}

const UINT32 HC_getPrimeCount( const UINT32 u32LBound, const UINT32 u32UBound )
{
	return _HC_getPrimeCount( u32LBound, u32UBound );
}

const UINT32 HC_getPrimeList( UINT32 * const lpPrimeBuffer, const UINT32 u32BufferSize, const UINT32 u32LBound, const UINT32 u32UBound )
{
	return _HC_getPrimeList( lpPrimeBuffer, u32BufferSize, u32LBound, u32UBound );
}

/* gives the Euler totient function (n). */
const UINT32 HC_EulerPhi( const UINT32 n )
{
	return _HC_EulerPhi( n );
}

/* gives the Jacobi symbol(n/m). */
const SINT32 HC_JacobiSymbol( const UINT32 n, const UINT32 m )
{
	return _HC_JacobiSymbol( n, m );
}

/* gives the multiplicative order of k modulo n, defined as the smallest integer x such that k^x  1 mod n. */
const UINT32 HC_MultiplicativeOrder( const UINT32 k, const UINT32 n )
{
	return _HC_MultiplicativeOrder( k, n );
}

/* give a primitive root of n, where n is a prime power or twice a prime power. */
const UINT32 HC_PrimitiveRoot( const UINT32 n )
{
	return _HC_PrimitiveRoot( n );
}


/* Greatest Common Divisor */
const UINT32 HC_gcd( const UINT32 u32Num1, const UINT32 u32Num2 )
{
	return _HC_gcd( u32Num1, u32Num2 );
}

const UINT32 HC_gcd_v32( const LPCVECTOR_UINT32 pVector )
{
	return _HC_gcd_v32( pVector );
}

/* GcdEx: g = GcdEx( x, y, u, v ) = u * x + v * y. g is always positive, even if one or both of u and v are negative. */
const UINT32 HC_gcdEx( SINT32 * const x, SINT32 * const y, const SINT32 u, const SINT32 v )
{
	return _HC_gcdEx( x, y, u, v );
}

const UINT32 HC_invertMod( const UINT32 u32InvertBase, const UINT32 u32Mod )
{
	return _HC_invertMod( u32InvertBase, u32Mod );
}

/* Lowest Common Multiple */
const UINT64 HC_lcm( const UINT32 u32Num1, const UINT32 u32Num2 )
{
	return _HC_lcm( u32Num1, u32Num2 );
}

/* PowMod */
const UINT32 HC_powMod( const UINT32 u32Base, const UINT32 u32Exp, const UINT32 u32Mod )
{
	return _HC_powMod( u32Base, u32Exp, u32Mod );
}



#ifndef _NO_HI
/* constructor */
HHUGEINT HI_new( void )
{
	return _HI_new();
}

/* destructor */
void HI_delete( HHUGEINT hHugeInt )
{
	_HI_delete( hHugeInt );
}

const UINT32 HI_getCount( void )
{
	return _HI_getCount();
}

/* reload operators */
HHUGEINT HI_set_s32( HHUGEINT hHugeInt, const SINT32 s32Num )
{
	return _HI_set_s32( hHugeInt, s32Num );
}

HHUGEINT HI_set_s64( HHUGEINT hHugeInt, const SINT64 s64Num )
{
	return _HI_set_s64( hHugeInt, s64Num );
}

HHUGEINT HI_set_u64( HHUGEINT hHugeInt, const UINT64 u64Num )
{
	return _HI_set_u64( hHugeInt, u64Num );
}

HHUGEINT HI_set_u32( HHUGEINT hHugeInt, const UINT32 u32Num )
{
	return _HI_set_u32( hHugeInt, u32Num );
}

HHUGEINT HI_set_str( HHUGEINT hHugeInt, const LPCTSTR lpszNum )
{
	return _HI_set_str( hHugeInt, lpszNum );
}

HHUGEINT HI_set_hi( HHUGEINT hHugeInt, const HHUGEINT hRight )
{
	return _HI_set_hi( hHugeInt, hRight );
}

#ifndef _NO_HX
HHUGEINT HI_set_hx( HHUGEINT hHugeInt, const HHUGEINTX hRight )
{
	return _HI_set_hx( hHugeInt, hRight );
}
#endif	/* #ifndef _NO_HX */

#ifndef _NO_RC
HHUGEINT HI_set_rc( HHUGEINT hHugeInt, const HRADIXCONVERTER hRight )
{
	return _HI_set_rc( hHugeInt, hRight );
}
#endif	/* #ifndef _NO_RC */

HHUGEINT HI_setHexStr( HHUGEINT hHugeInt, const LPCTSTR lpszHexNum )
{
	return _HI_setHexStr( hHugeInt, lpszHexNum );
}

/* Return non-zero if the value of (*this) fits in SINT32, UINT32, SINT64 or UINT64, respectively. Otherwise, return zero. */
const SINT32 HI_get_s32( const HHUGEINT hHugeInt )
{
	return _HI_get_s32( hHugeInt );
}

const SINT64 HI_get_s64( const HHUGEINT hHugeInt )
{
	return _HI_get_s64( hHugeInt );
}

const UINT32 HI_get_u32( const HHUGEINT hHugeInt )
{
	return _HI_get_u32( hHugeInt );
}

const UINT64 HI_get_u64( const HHUGEINT hHugeInt )
{
	return _HI_get_u64( hHugeInt );
}

/* CompareAbs */
const SINT32 HI_compareAbs_s32( const HHUGEINT hLeft, const SINT32 s32Num )
{
	return _HI_compareAbs_s32( hLeft, s32Num );
}

const SINT32 HI_compareAbs_u32( const HHUGEINT hLeft, const UINT32 u32Num )
{
	return _HI_compareAbs_u32( hLeft, u32Num );
}

const SINT32 HI_compareAbs_hi( const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_compareAbs_hi( hLeft, hRight );
}

/* Compare */
const SINT32 HI_compare_s32( const HHUGEINT hLeft, const SINT32 s32Num )
{
	return _HI_compare_s32( hLeft, s32Num );
}

const SINT32 HI_compare_u32( const HHUGEINT hLeft, const UINT32 u32Num )
{
	return _HI_compare_u32( hLeft, u32Num );
}

const SINT32 HI_compare_hi( const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_compare_hi( hLeft, hRight );
}

/* get property */
const SIGN HI_getSign( const HHUGEINT hHugeInt )
{
	return _HI_getSign( hHugeInt );
}

const BOOL HI_isZero( const HHUGEINT hHugeInt )
{
	return _HI_isZero( hHugeInt );
}

const BOOL HI_isAbsOne( const HHUGEINT hHugeInt )
{
	return _HI_isAbsOne( hHugeInt );
}

const BOOL HI_isOdd( const HHUGEINT hHugeInt )
{
	return _HI_isOdd( hHugeInt );
}

const BOOL HI_isEven( const HHUGEINT hHugeInt )
{
	return _HI_isEven( hHugeInt );
}

const BOOL HI_isPrime( const HHUGEINT hHugeInt )
{
	return _HI_isPrime( hHugeInt );
}

const PRIMALITY HI_testPrimality( const HHUGEINT hHugeInt, const UINT32 u32Repeat /*= 5*/ )
{
	return _HI_testPrimality( hHugeInt, u32Repeat );
}

const UINT32 HI_getBits( const HHUGEINT hHugeInt )
{
	return _HI_getBits( hHugeInt );
}

const UINT32 HI_getDigits( const HHUGEINT hHugeInt )
{
	return _HI_getDigits( hHugeInt );
}

const UINT32 HI_getTailDecZeros( const HHUGEINT hHugeInt )
{
	return _HI_getTailDecZeros( hHugeInt );
}

HHUGEINT HI_bitLShift( HHUGEINT hHugeInt, const UINT32 u32BitLShift )
{
	return _HI_bitLShift( hHugeInt, u32BitLShift );
}

HHUGEINT HI_bitRShift( HHUGEINT hHugeInt, const UINT32 u32BitRShift )
{
	return _HI_bitRShift( hHugeInt, u32BitRShift );
}

/* notice: base on decimal system !! */
HHUGEINT HI_decLShift( HHUGEINT hHugeInt, const UINT32 u32DecLShift )
{
	return _HI_decLShift( hHugeInt, u32DecLShift );
}

HHUGEINT HI_decRShift( HHUGEINT hHugeInt, const UINT32 u32DecRShift )
{
	return _HI_decRShift( hHugeInt, u32DecRShift );
}

HHUGEINT HI_bitAnd( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_bitAnd( hResult, hLeft, hRight );
}

HHUGEINT HI_bitXor( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_bitXor( hResult, hLeft, hRight );
}

HHUGEINT HI_bitOr( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_bitOr( hResult, hLeft, hRight );
}

HHUGEINT HI_abs( HHUGEINT hHugeInt )
{
	return _HI_abs( hHugeInt );
}

HHUGEINT HI_negate( HHUGEINT hHugeInt )
{
	return _HI_negate( hHugeInt );
}

HHUGEINT HI_swap( HHUGEINT hLeft, HHUGEINT hRight )
{
	return _HI_swap( hLeft, hRight );
}

HHUGEINT HI_ceil( HHUGEINT hHugeInt, const UINT32 u32DecDigits )
{
	return _HI_ceil( hHugeInt, u32DecDigits );
}

HHUGEINT HI_truncate( HHUGEINT hHugeInt, const UINT32 u32DecDigits )
{
	return _HI_truncate( hHugeInt, u32DecDigits );
}

HHUGEINT HI_floor( HHUGEINT hHugeInt, const UINT32 u32DecDigits )
{
	return _HI_floor( hHugeInt, u32DecDigits );
}

HHUGEINT HI_random( HHUGEINT hHugeInt, const UINT32 u32DecDigits )
{
	return _HI_random( hHugeInt, u32DecDigits );
}

HHUGEINT HI_generatePrime( HHUGEINT hHugeInt, const UINT32 u32DecDigits )
{
	return _HI_generatePrime( hHugeInt, u32DecDigits );
}

HHUGEINT HI_previousPrime( HHUGEINT hResult, const HHUGEINT hBenchmark )
{
	return _HI_previousPrime( hResult, hBenchmark );
}

HHUGEINT HI_nextPrime( HHUGEINT hResult, const HHUGEINT hBenchmark )
{
	return _HI_nextPrime( hResult, hBenchmark );
}

/* + */
HHUGEINT HI_add( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_add( hResult, hLeft, hRight );
}

HHUGEINT HI_add_u32( HHUGEINT hResult, const HHUGEINT hLeft, const UINT32 u32Num )
{
	return _HI_add_u32( hResult, hLeft, u32Num );
}

/* - */
HHUGEINT HI_sub( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_sub( hResult, hLeft, hRight );
}

HHUGEINT HI_sub_u32( HHUGEINT hResult, const HHUGEINT hLeft, const UINT32 u32Num )
{
	return _HI_sub_u32( hResult, hLeft, u32Num );
}

/* * */
HHUGEINT HI_mul( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_mul( hResult, hLeft, hRight );
}

HHUGEINT HI_mul_u32( HHUGEINT hResult, const HHUGEINT hLeft, const UINT32 u32Num )
{
	return _HI_mul_u32( hResult, hLeft, u32Num );
}

/* Division, return quotient */
HHUGEINT HI_divRem( HHUGEINT hQuotient, const HHUGEINT hDividend, const HHUGEINT hDivisor, HHUGEINT hRemainder /*= NULL*/ )
{
	return _HI_divRem( hQuotient, hDividend, hDivisor, hRemainder );
}

HHUGEINT HI_div_s32( HHUGEINT hQuotient, const HHUGEINT hDividend, const SINT32 s32Divisor, SINT32 * const pRemainder /*= NULL*/ )
{
	return _HI_div_s32( hQuotient, hDividend, s32Divisor, pRemainder );
}

/* % */
HHUGEINT HI_mod( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_mod( hResult, hLeft, hRight );
}

/* Power */
HHUGEINT HI_pow( HHUGEINT hResult, const HHUGEINT hBase, const UINT32 u32Exp )
{
	return _HI_pow( hResult, hBase, u32Exp );
}

/* Extraction */
HHUGEINT HI_rootRem( HHUGEINT hRoot, const HHUGEINT hRadicand, const UINT32 u32Exp, HHUGEINT hRemainder /*= NULL*/, BOOL * const pIsReal /*= NULL*/ )
{
	return _HI_rootRem( hRoot, hRadicand, u32Exp, hRemainder, pIsReal );
}

/* Logarithm */
const UINT32 HI_log_u32( const HHUGEINT hHugeInt, const UINT32 u32Base, BOOL * const pIsExact /*= NULL*/ )
{
	return _HI_log_u32( hHugeInt, u32Base, pIsExact );
}

const UINT32 HI_log( const HHUGEINT hHugeInt, const HHUGEINT hBase, BOOL * const pIsExact /*= NULL*/ )
{
	return _HI_log( hHugeInt, hBase, pIsExact );
}

/* PrimeFactorial(n) gives the product of the first n primes. */
HHUGEINT HI_primeFactorial( HHUGEINT hResult, const UINT32 u32Index )
{
	return _HI_primeFactorial( hResult, u32Index );
}

/* Primorial(n) gives the product of the primes less than or equal to n. */
HHUGEINT HI_primorial( HHUGEINT hResult, const UINT32 u32Num )
{
	return _HI_primorial( hResult, u32Num );
}

/* Factorial, Permutation, Combination */
HHUGEINT HI_factorial( HHUGEINT hResult, const UINT32 n )
{
	return _HI_factorial( hResult, n );
}

HHUGEINT HI_factorial2( HHUGEINT hResult, const UINT32 n )
{
	return _HI_factorial2( hResult, n );
}

HHUGEINT HI_permutation( HHUGEINT hResult, const UINT32 n, const UINT32 r )
{
	return _HI_permutation( hResult, n, r );
}

HHUGEINT HI_combination( HHUGEINT hResult, const UINT32 n, const UINT32 r )
{
	return _HI_combination( hResult, n, r );
}

/* Fibonacci numbers */
HHUGEINT HI_fibonacci( HHUGEINT hResult, const SINT32 n )
{
	return _HI_fibonacci( hResult, n );
}

/* Lucas numbers */
HHUGEINT HI_lucas( HHUGEINT hResult, const SINT32 n )
{
	return _HI_lucas( hResult, n );
}


/* MulMod */
HHUGEINT HI_mulMod( HHUGEINT hResult, const HHUGEINT hMultiplicand, const HHUGEINT hMultiplier, const HHUGEINT hMod )
{
	return _HI_mulMod( hResult, hMultiplicand, hMultiplier, hMod );
}

/* InvertMod: x = InvertMod( b, m ) && !(!x) <==> ( b * x ) mod m = 1 */
HHUGEINT HI_invertMod_u32( HHUGEINT hResult, const UINT32 u32InvertBase, const HHUGEINT hMod )
{
	return _HI_invertMod_u32( hResult, u32InvertBase, hMod );
}

HHUGEINT HI_invertMod( HHUGEINT hResult, const HHUGEINT hInvertBase, const HHUGEINT hMod )
{
	return _HI_invertMod( hResult, hInvertBase, hMod );
}

/* PowMod */
const UINT32 HI_powMod_u32_u32( const UINT32 u32Base, const HHUGEINT hExp, const UINT32 u32Mod )
{
	return _HI_powMod_u32_u32( u32Base, hExp, u32Mod );
}

HHUGEINT HI_powMod_u32( HHUGEINT hResult, const UINT32 u32Base, const HHUGEINT hExp, const HHUGEINT hMod )
{
	return _HI_powMod_u32( hResult, u32Base, hExp, hMod );
}

HHUGEINT HI_powMod( HHUGEINT hResult, const HHUGEINT hBase, const HHUGEINT hExp, const HHUGEINT hMod )
{
	return _HI_powMod( hResult, hBase, hExp, hMod );
}

/* ModPowTen: *this %= 10^u32Exp */
HHUGEINT HI_modPowTen( HHUGEINT hHugeInt, const UINT32 u32Exp )
{
	return _HI_modPowTen( hHugeInt, u32Exp );
}

/* Greatest Common Divisor */
HHUGEINT HI_gcd( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_gcd( hResult, hLeft, hRight );
}

HHUGEINT HI_gcd_vhi( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector )
{
	return _HI_gcd_vhi( hResult, pVector );
}

/* GcdEx: g = GcdEx( x, y, u, v ) = u * x + v * y. g is always positive, even if one or both of u and v are negative. */
HHUGEINT HI_gcdEx( HHUGEINT hResult, HHUGEINT x, HHUGEINT y, const HHUGEINT u, const HHUGEINT v )
{
	return _HI_gcdEx( hResult, x, y, u, v );
}

/* Lowest Common Multiple */
HHUGEINT HI_lcm( HHUGEINT hResult, const HHUGEINT hLeft, const HHUGEINT hRight )
{
	return _HI_lcm( hResult, hLeft, hRight );
}

HHUGEINT HI_lcm_v32( HHUGEINT hResult, const LPCVECTOR_UINT32 pVector )
{
	return _HI_lcm_v32( hResult, pVector );
}

HHUGEINT HI_lcm_vhi( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector )
{
	return _HI_lcm_vhi( hResult, pVector );
}

HHUGEINT HI_product_v32( HHUGEINT hResult, const LPCVECTOR_UINT32 pVector )
{
	return _HI_product_v32( hResult, pVector );
}

HHUGEINT HI_product_vhi( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector )
{
	return _HI_product_vhi( hResult, pVector );
}

/* if u32Exp==0, then call function: Product( ... ) */
HHUGEINT HI_sumsOfLikePowers_v32( HHUGEINT hResult, const LPCVECTOR_UINT32 pVector, const UINT32 u32Exp /*= 1*/ )
{
	return _HI_sumsOfLikePowers_v32( hResult, pVector, u32Exp );
}

HHUGEINT HI_sumsOfLikePowers_vhi( HHUGEINT hResult, const LPCVECTOR_HHUGEINT pVector, const UINT32 u32Exp /*= 1*/ )
{
	return _HI_sumsOfLikePowers_vhi( hResult, pVector, u32Exp );
}

/* Output */
const LPCTSTR HI_getStr( const HHUGEINT hHugeInt, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ )
{
	return _HI_getStr( hHugeInt, byFormat, pStrLen );
}

/* no "0x" */
const LPCTSTR HI_getHexStr( const HHUGEINT hHugeInt, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ )
{
	return _HI_getHexStr( hHugeInt, byFormat, pStrLen );
}

/* This function can convert the huge integer to a string of digits in another Radix system. */
const LPCTSTR HI_getStrRadix( const HHUGEINT hHugeInt, const UINT32 u32Radix /*= 16*/, UINT32 * const pDigits /*= NULL*/, const BYTE byFormat /*= FS_DEFAULT*/, const UINT32 u32BandLength /*= 4*/, UINT32 * const pStrLen /*= NULL*/ )
{
	return _HI_getStrRadix( hHugeInt, u32Radix, pDigits, byFormat, u32BandLength, pStrLen );
}

void HI_freeStrBuffer( const HHUGEINT hHugeInt )
{
	_HI_freeStrBuffer( hHugeInt );
}
#endif	/* #ifndef _NO_HI */



#ifndef _NO_HX
/* constructor */
HHUGEINTX HX_new( void )
{
	return _HX_new();
}

/* destructor */
void HX_delete( HHUGEINTX hHugeIntX )
{
	_HX_delete( hHugeIntX );
}

const UINT32 HX_getCount( void )
{
	return _HX_getCount();
}

/* reload operators */
HHUGEINTX HX_set_s32( HHUGEINTX hHugeIntX, const SINT32 s32Num )
{
	return _HX_set_s32( hHugeIntX, s32Num );
}

HHUGEINTX HX_set_s64( HHUGEINTX hHugeIntX, const SINT64 s64Num )
{
	return _HX_set_s64( hHugeIntX, s64Num );
}

HHUGEINTX HX_set_u32( HHUGEINTX hHugeIntX, const UINT32 u32Num )
{
	return _HX_set_u32( hHugeIntX, u32Num );
}

HHUGEINTX HX_set_u64( HHUGEINTX hHugeIntX, const UINT64 u64Num )
{
	return _HX_set_u64( hHugeIntX, u64Num );
}

HHUGEINTX HX_set_str( HHUGEINTX hHugeIntX, const LPCTSTR lpszNum )
{
	return _HX_set_str( hHugeIntX, lpszNum );
}

#ifndef _NO_HI
HHUGEINTX HX_set_hi( HHUGEINTX hHugeIntX, const HHUGEINT hRight )
{
	return _HX_set_hi( hHugeIntX, hRight );
}
#endif	/* #ifndef _NO_HI */

HHUGEINTX HX_set_hx( HHUGEINTX hHugeIntX, const HHUGEINTX hRight )
{
	return _HX_set_hx( hHugeIntX, hRight );
}

#ifndef _NO_RC
HHUGEINTX HX_set_rc( HHUGEINTX hHugeIntX, const HRADIXCONVERTER hRight )
{
	return _HX_set_rc( hHugeIntX, hRight );
}
#endif	/* #ifndef _NO_RC */

HHUGEINTX HX_setHexStr( HHUGEINTX hHugeIntX, const LPCTSTR lpszHexNum )
{
	return _HX_setHexStr( hHugeIntX, lpszHexNum );
}

HHUGEINTX HX_setText( HHUGEINTX hHugeIntX, const LPCTSTR lpszText )
{
	return _HX_setText( hHugeIntX, lpszText );
}

/* Return non-zero if the value of (*this) fits in SINT32, UINT32, SINT64 or UINT64, respectively. Otherwise, return zero. */
const SINT32 HX_get_s32( const HHUGEINTX hHugeIntX )
{
	return _HX_get_s32( hHugeIntX );
}

const SINT64 HX_get_s64( const HHUGEINTX hHugeIntX )
{
	return _HX_get_s64( hHugeIntX );
}

const UINT32 HX_get_u32( const HHUGEINTX hHugeIntX )
{
	return _HX_get_u32( hHugeIntX );
}

const UINT64 HX_get_u64( const HHUGEINTX hHugeIntX )
{
	return _HX_get_u64( hHugeIntX );
}

/* CompareAbs */
const SINT32 HX_compareAbs_s32( const HHUGEINTX hLeft, const SINT32 s32Num )
{
	return _HX_compareAbs_s32( hLeft, s32Num );
}

const SINT32 HX_compareAbs_u32( const HHUGEINTX hLeft, const UINT32 u32Num )
{
	return _HX_compareAbs_u32( hLeft, u32Num );
}

const SINT32 HX_compareAbs_hx( const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_compareAbs_hx( hLeft, hRight );
}

/* Compare */
const SINT32 HX_compare_s32( const HHUGEINTX hLeft, const SINT32 s32Num )
{
	return _HX_compare_s32( hLeft, s32Num );
}

const SINT32 HX_compare_u32( const HHUGEINTX hLeft, const UINT32 u32Num )
{
	return _HX_compare_u32( hLeft, u32Num );
}

const SINT32 HX_compare_hx( const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_compare_hx( hLeft, hRight );
}

/* get property */
const SIGN HX_getSign( const HHUGEINTX hHugeIntX )
{
	return _HX_getSign( hHugeIntX );
}

const BOOL HX_isZero( const HHUGEINTX hHugeIntX )
{
	return _HX_isZero( hHugeIntX );
}

const BOOL HX_isAbsOne( const HHUGEINTX hHugeIntX )
{
	return _HX_isAbsOne( hHugeIntX );
}

const BOOL HX_isOdd( const HHUGEINTX hHugeIntX )
{
	return _HX_isOdd( hHugeIntX );
}

const BOOL HX_isEven( const HHUGEINTX hHugeIntX )
{
	return _HX_isEven( hHugeIntX );
}

const BOOL HX_isBitOne( const HHUGEINTX hHugeIntX, const UINT32 u32BitIndex )
{
	return _HX_isBitOne( hHugeIntX, u32BitIndex );
}

const BOOL HX_isPrime( const HHUGEINTX hHugeIntX )
{
	return _HX_isPrime( hHugeIntX );
}

const PRIMALITY HX_testPrimality( const HHUGEINTX hHugeIntX, const UINT32 u32Repeat /*= 5*/ )
{
	return _HX_testPrimality( hHugeIntX, u32Repeat );
}

const UINT32 HX_getBits( const HHUGEINTX hHugeIntX )
{
	return _HX_getBits( hHugeIntX );
}

const UINT32 HX_getDigits( const HHUGEINTX hHugeIntX )
{
	return _HX_getDigits( hHugeIntX );
}

const UINT32 HX_getTailBitZeros( const HHUGEINTX hHugeIntX )
{
	return _HX_getTailBitZeros( hHugeIntX );
}

HHUGEINTX HX_bitLShift( HHUGEINTX hHugeIntX, const UINT32 u32BitLShift )
{
	return _HX_bitLShift( hHugeIntX, u32BitLShift );
}

HHUGEINTX HX_bitRShift( HHUGEINTX hHugeIntX, const UINT32 u32BitRShift )
{
	return _HX_bitRShift( hHugeIntX, u32BitRShift );
}

HHUGEINTX HX_bitAnd( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_bitAnd( hResult, hLeft, hRight );
}

HHUGEINTX HX_bitXor( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_bitXor( hResult, hLeft, hRight );
}

HHUGEINTX HX_bitOr( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_bitOr( hResult, hLeft, hRight );
}

HHUGEINTX HX_abs( HHUGEINTX hHugeIntX )
{
	return _HX_abs( hHugeIntX );
}

HHUGEINTX HX_negate( HHUGEINTX hHugeIntX )
{
	return _HX_negate( hHugeIntX );
}

HHUGEINTX HX_swap( HHUGEINTX hLeft, HHUGEINTX hRight )
{
	return _HX_swap( hLeft, hRight );
}


HHUGEINTX HX_ceil( HHUGEINTX hHugeIntX, const UINT32 u32Bits )
{
	return _HX_ceil( hHugeIntX, u32Bits );
}

HHUGEINTX HX_truncate( HHUGEINTX hHugeIntX, const UINT32 u32Bits )
{
	return _HX_truncate( hHugeIntX, u32Bits );
}

HHUGEINTX HX_floor( HHUGEINTX hHugeIntX, const UINT32 u32Bits )
{
	return _HX_floor( hHugeIntX, u32Bits );
}

HHUGEINTX HX_random( HHUGEINTX hHugeIntX, const UINT32 u32Bits )
{
	return _HX_random( hHugeIntX, u32Bits );
}

HHUGEINTX HX_generatePrime( HHUGEINTX hHugeIntX, const UINT32 u32Bits )
{
	return _HX_generatePrime( hHugeIntX, u32Bits );
}

HHUGEINTX HX_previousPrime( HHUGEINTX hResult, const HHUGEINTX hBenchmark )
{
	return _HX_previousPrime( hResult, hBenchmark );
}

HHUGEINTX HX_nextPrime( HHUGEINTX hResult, const HHUGEINTX hBenchmark )
{
	return _HX_nextPrime( hResult, hBenchmark );
}

/* + */
HHUGEINTX HX_add( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_add( hResult, hLeft, hRight );
}

HHUGEINTX HX_add_u32( HHUGEINTX hResult, const HHUGEINTX hLeft, const UINT32 u32Num )
{
	return _HX_add_u32( hResult, hLeft, u32Num );
}

/* - */
HHUGEINTX HX_sub( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_sub( hResult, hLeft, hRight );
}

HHUGEINTX HX_sub_u32( HHUGEINTX hResult, const HHUGEINTX hLeft, const UINT32 u32Num )
{
	return _HX_sub_u32( hResult, hLeft, u32Num );
}

/* * */
HHUGEINTX HX_mul( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_mul( hResult, hLeft, hRight );
}

HHUGEINTX HX_mul_u32( HHUGEINTX hResult, const HHUGEINTX hLeft, const UINT32 u32Num )
{
	return _HX_mul_u32( hResult, hLeft, u32Num );
}

/* Division, return quotient */
HHUGEINTX HX_divRem( HHUGEINTX hQuotient, const HHUGEINTX hDividend, const HHUGEINTX hDivisor, HHUGEINTX hRemainder /*= NULL*/ )
{
	return _HX_divRem( hQuotient, hDividend, hDivisor, hRemainder );
}

HHUGEINTX HX_div_s32( HHUGEINTX hQuotient, const HHUGEINTX hDividend, const SINT32 s32Divisor, SINT32 * const pRemainder /*= NULL*/ )
{
	return _HX_div_s32( hQuotient, hDividend, s32Divisor, pRemainder );
}

/* % */
HHUGEINTX HX_mod( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_mod( hResult, hLeft, hRight );
}

/* Power */
HHUGEINTX HX_pow( HHUGEINTX hResult, const HHUGEINTX hBase, const UINT32 u32Exp )
{
	return _HX_pow( hResult, hBase, u32Exp );
}

/* Extraction */
HHUGEINTX HX_rootRem( HHUGEINTX hRoot, const HHUGEINTX hRadicand, const UINT32 u32Exp, HHUGEINTX hRemainder /*= NULL*/, BOOL * const pIsReal /*= NULL*/ )
{
	return _HX_rootRem( hRoot, hRadicand, u32Exp, hRemainder, pIsReal );
}

/* Logarithm */
const UINT32 HX_log_u32( const HHUGEINTX hHugeIntX, const UINT32 u32Base, BOOL * const pIsExact /*= NULL*/ )
{
	return _HX_log_u32( hHugeIntX, u32Base, pIsExact );
}

const UINT32 HX_log( const HHUGEINTX hHugeIntX, const HHUGEINTX hBase, BOOL * const pIsExact /*= NULL*/ )
{
	return _HX_log( hHugeIntX, hBase, pIsExact );
}

/* PrimeFactorial(n) gives the product of the first n primes. */
HHUGEINTX HX_primeFactorial( HHUGEINTX hResult, const UINT32 u32Index )
{
	return _HX_primeFactorial( hResult, u32Index );
}

/* Primorial(n) gives the product of the primes less than or equal to n. */
HHUGEINTX HX_primorial( HHUGEINTX hResult, const UINT32 u32Num )
{
	return _HX_primorial( hResult, u32Num );
}

/* Factorial, Permutation, Combination */
HHUGEINTX HX_factorial( HHUGEINTX hResult, const UINT32 n )
{
	return _HX_factorial( hResult, n );
}

HHUGEINTX HX_factorial2( HHUGEINTX hResult, const UINT32 n )
{
	return _HX_factorial2( hResult, n );
}

HHUGEINTX HX_permutation( HHUGEINTX hResult, const UINT32 n, const UINT32 r )
{
	return _HX_permutation( hResult, n, r );
}

HHUGEINTX HX_combination( HHUGEINTX hResult, const UINT32 n, const UINT32 r )
{
	return _HX_combination( hResult, n, r );
}

/* Fibonacci numbers */
HHUGEINTX HX_fibonacci( HHUGEINTX hResult, const SINT32 n )
{
	return _HX_fibonacci( hResult, n );
}

/* Lucas numbers */
HHUGEINTX HX_lucas( HHUGEINTX hResult, const SINT32 n )
{
	return _HX_lucas( hResult, n );
}

/* MulMod */
HHUGEINTX HX_mulMod( HHUGEINTX hResult, const HHUGEINTX hMultiplicand, const HHUGEINTX hMultiplier, const HHUGEINTX hMod )
{
	return _HX_mulMod( hResult, hMultiplicand, hMultiplier, hMod );
}

/* InvertMod: x = InvertMod( b, m ) && !(!x) <==> ( b * x ) mod m = 1 */
HHUGEINTX HX_invertMod_u32( HHUGEINTX hResult, const UINT32 u32InvertBase, const HHUGEINTX hMod )
{
	return _HX_invertMod_u32( hResult, u32InvertBase, hMod );
}

HHUGEINTX HX_invertMod( HHUGEINTX hResult, const HHUGEINTX hInvertBase, const HHUGEINTX hMod )
{
	return _HX_invertMod( hResult, hInvertBase, hMod );
}

/* PowMod */
const UINT32 HX_powMod_u32_u32( const UINT32 u32Base, const HHUGEINTX hExp, const UINT32 u32Mod )
{
	return _HX_powMod_u32_u32( u32Base, hExp, u32Mod );
}

HHUGEINTX HX_powMod_u32( HHUGEINTX hResult, const UINT32 u32Base, const HHUGEINTX hExp, const HHUGEINTX hMod )
{
	return _HX_powMod_u32( hResult, u32Base, hExp, hMod );
}

HHUGEINTX HX_powMod( HHUGEINTX hResult, const HHUGEINTX hBase, const HHUGEINTX hExp, const HHUGEINTX hMod )
{
	return _HX_powMod( hResult, hBase, hExp, hMod );
}

/* ModPowTen: *this %= 2^u32Exp */
HHUGEINTX HX_modPowTwo( HHUGEINTX hHugeIntX, const UINT32 u32Exp )
{
	return _HX_modPowTwo( hHugeIntX, u32Exp );
}

/* Greatest Common Divisor */
HHUGEINTX HX_gcd( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_gcd( hResult, hLeft, hRight );
}

HHUGEINTX HX_gcd_vhx( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector )
{
	return _HX_gcd_vhx( hResult, pVector );
}

/* GcdEx: g = GcdEx( x, y, u, v ) = u * x + v * y. g is always positive, even if one or both of u and v are negative. */
HHUGEINTX HX_gcdEx( HHUGEINTX hResult, HHUGEINTX x, HHUGEINTX y, const HHUGEINTX u, const HHUGEINTX v )
{
	return _HX_gcdEx( hResult, x, y, u, v );
}

/* Lowest Common Multiple */
HHUGEINTX HX_lcm( HHUGEINTX hResult, const HHUGEINTX hLeft, const HHUGEINTX hRight )
{
	return _HX_lcm( hResult, hLeft, hRight );
}

HHUGEINTX HX_lcm_v32( HHUGEINTX hResult, const LPCVECTOR_UINT32 pVector )
{
	return _HX_lcm_v32( hResult, pVector );
}

HHUGEINTX HX_lcm_vhx( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector )
{
	return _HX_lcm_vhx( hResult, pVector );
}

HHUGEINTX HX_product_v32( HHUGEINTX hResult, const LPCVECTOR_UINT32 pVector )
{
	return _HX_product_v32( hResult, pVector );
}

HHUGEINTX HX_product_vhx( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector )
{
	return _HX_product_vhx( hResult, pVector );
}

/* if u32Exp==0, then call function: Product( ... ) */
HHUGEINTX HX_sumsOfLikePowers_v32( HHUGEINTX hResult, const LPCVECTOR_UINT32 pVector, const UINT32 u32Exp /*= 1*/ )
{
	return _HX_sumsOfLikePowers_v32( hResult, pVector, u32Exp );
}

HHUGEINTX HX_sumsOfLikePowers_vhx( HHUGEINTX hResult, const LPCVECTOR_HHUGEINTX pVector, const UINT32 u32Exp /*= 1*/ )
{
	return _HX_sumsOfLikePowers_vhx( hResult, pVector, u32Exp );
}

/* Output */
const LPCTSTR HX_getStr( const HHUGEINTX hHugeIntX, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ )
{
	return _HX_getStr( hHugeIntX, byFormat, pStrLen );
}

/* no "0x" */
const LPCTSTR HX_getHexStr( const HHUGEINTX hHugeIntX, const BYTE byFormat /*= FS_DEFAULT*/, UINT32 * const pStrLen /*= NULL*/ )
{
	return _HX_getHexStr( hHugeIntX, byFormat, pStrLen );
}

/* This function can convert the huge integer to a string of digits in another Radix system. */
const LPCTSTR HX_getStrRadix( const HHUGEINTX hHugeIntX, const UINT32 u32Radix /*= 10*/, UINT32 * const pDigits /*= NULL*/, const BYTE byFormat /*= FS_DEFAULT*/, const UINT32 u32BandLength /*= 3*/, UINT32 * const pStrLen /*= NULL*/ )
{
	return _HX_getStrRadix( hHugeIntX, u32Radix, pDigits, byFormat, u32BandLength, pStrLen );
}

const LPCTSTR HX_getText( const HHUGEINTX hHugeIntX )
{
	return _HX_getText( hHugeIntX );
}

void HX_freeStrBuffer( const HHUGEINTX hHugeIntX )
{
	_HX_freeStrBuffer( hHugeIntX );
}
#endif	/* #ifndef _NO_HI */



#ifndef _NO_RC
HRADIXCONVERTER RC_new( const UINT32 u32Radix )
{
	return _RC_new( u32Radix );
}

HRADIXCONVERTER RC_new_str( const UINT32 u32Radix, const LPCTSTR lpszNum )
{
	return _RC_new_str( u32Radix, lpszNum );
}

void RC_delete( HRADIXCONVERTER hRadixConverter )
{
	_RC_delete( hRadixConverter );
}

const UINT32 RC_getCount( void )
{
	return _RC_getCount();
}

HRADIXCONVERTER RC_convert2Radix( HRADIXCONVERTER hRadixConverter, const UINT32 u32NewRadix )
{
	return _RC_convert2Radix( hRadixConverter, u32NewRadix );
}

#ifndef _NO_HI
HRADIXCONVERTER RC_set_hi( HRADIXCONVERTER hRadixConverter, const HHUGEINT hRight )
{
	return _RC_set_hi( hRadixConverter, hRight );
}
#endif	/* #ifndef _NO_HI */

#ifndef _NO_HX
HRADIXCONVERTER RC_set_hx( HRADIXCONVERTER hRadixConverter, const HHUGEINTX hRight )
{
	return _RC_set_hx( hRadixConverter, hRight );
}
#endif	/* #ifndef _NO_HX */

HRADIXCONVERTER RC_set_rc( HRADIXCONVERTER hRadixConverter, const HRADIXCONVERTER hRight )
{
	return _RC_set_rc( hRadixConverter, hRight );
}

HRADIXCONVERTER RC_set_s32( HRADIXCONVERTER hRadixConverter, const SINT32 s32Num )
{
	return _RC_set_s32( hRadixConverter, s32Num );
}

HRADIXCONVERTER RC_set_s64( HRADIXCONVERTER hRadixConverter, const SINT64 s64Num )
{
	return _RC_set_s64( hRadixConverter, s64Num );
}

HRADIXCONVERTER RC_set_u32( HRADIXCONVERTER hRadixConverter, const UINT32 u32Num )
{
	return _RC_set_u32( hRadixConverter, u32Num );
}

HRADIXCONVERTER RC_set_u64( HRADIXCONVERTER hRadixConverter, const UINT64 u64Num )
{
	return _RC_set_u64( hRadixConverter, u64Num );
}

/* Return non-zero if the value of (*this) fits in SINT32, UINT32, SINT64 or UINT64, respectively. Otherwise, return zero. */
const SINT32 RC_get_s32( const HRADIXCONVERTER hRadixConverter )
{
	return _RC_get_s32( hRadixConverter );
}

const SINT64 RC_get_s64( const HRADIXCONVERTER hRadixConverter )
{
	return _RC_get_s64( hRadixConverter );
}

const UINT32 RC_get_u32( const HRADIXCONVERTER hRadixConverter )
{
	return _RC_get_u32( hRadixConverter );
}

const UINT64 RC_get_u64( const HRADIXCONVERTER hRadixConverter )
{
	return _RC_get_u64( hRadixConverter );
}

void RC_resetRadix( HRADIXCONVERTER hRadixConverter, const UINT32 u32Radix )
{
	_RC_resetRadix( hRadixConverter, u32Radix );
}

void RC_resetSign( HRADIXCONVERTER hRadixConverter, const SIGN enumSign )
{
	_RC_resetSign( hRadixConverter, enumSign );
}

void RC_resetVector( HRADIXCONVERTER hRadixConverter, const LPCVECTOR_UINT32 pVector )
{
	_RC_resetVector( hRadixConverter, pVector );
}

void RC_clearVector( HRADIXCONVERTER hRadixConverter )
{
	_RC_clearVector( hRadixConverter );
}

const UINT32 RC_getRadix( const HRADIXCONVERTER hRadixConverter )
{
	return _RC_getRadix( hRadixConverter );
}

const SIGN RC_getSign( const HRADIXCONVERTER hRadixConverter )
{
	return _RC_getSign( hRadixConverter );
}

const LPCVECTOR_UINT32 RC_getVector( const HRADIXCONVERTER hRadixConverter, const PCVECTOR_UINT32 pVector )
{
	return _RC_getVector( hRadixConverter, pVector );
}

const UINT64 RC_sumOfDigits( const HRADIXCONVERTER hRadixConverter )
{
	return _RC_sumOfDigits( hRadixConverter );
}
#endif	/* #ifndef _NO_RC */