// HugeCalcDemo.cpp : Defines the entry point for the console application.
//

//	Project -> Setting -> C/C++ -> Code Generation --> Use run-time library:
//		Win32 Debug:	Debug Multithreaded DLL
//		Win32 Release:	Multithreaded DLL

#include <iostream.h>

#include "../../../HugeCalc_API/CppAPI/Include/HugeCalc.h"	// ӿ
#include "../../../HugeCalc_API/CppAPI/Include/HugeInt.h"	// 10ϵͳ
#include "../../../HugeCalc_API/CppAPI/Include/HugeIntX.h"	// 16ϵͳ

#pragma message( "automatic link to ../../../HugeCalc_API/CppAPI/Lib/HugeCalc.lib" )
#pragma comment( lib, "../../../HugeCalc_API/CppAPI/Lib/HugeCalc.lib" )

//	http://www.swox.com/gmp/#TRY
//	1 + gcd(87324,78263148,7896) * (10^1989879887 mod 471!)

#if 1
	#define _Test_HI
	#define integer CHugeInt
#else
	#define _Test_HX
	#define integer CHugeIntX
#endif

int main(int argc, char* argv[])
{
//	printf("Hello World!\n");

	cout << "Call " << HugeCalc::GetVer() << endl << endl;

	if ( HC_LICENSE_NONE == HugeCalc::GetLicenseLevel())
	{
		cout << endl << "棺δͨ HugeCalc.dll ֤" \
			<< endl << endl << "ѡз֮һ" \
			<< endl <<	"    һ뽫ƶ/CopyrightByGuoXianqiang/[../]Ŀ¼У" \
			<< endl <<	"     HugeCalc.chm нעᣨһݣ" \
			<< endl << endl;
		system( "pause" );
		return (-1);
	}

	CONST UINT32 u32Num[] =  { 87324, 78263148, 7896 };
	CONST CVECTOR_UINT32 vU32Num( &(u32Num[0]), sizeof( u32Num ) / sizeof( u32Num[0] ) );

	integer hugeResult;

	// ʼ
	HugeCalc::EnableTimer( TRUE );
	HugeCalc::ResetTimer();

	hugeResult.PowMod( 10, 1989879887, integer().Factorial( 471 ));
	hugeResult *= HugeCalc::Gcd( vU32Num );
	++hugeResult;

	// ¼ʱ
	CONST UINT32 u32Timer_Calc = HugeCalc::GetTimer( TIMER_UNIT_ms );

	HugeCalc::ResetTimer();
	CONST LPCTSTR lpShow = hugeResult.GetStr( FS_DEFAULT );
	CONST UINT32 u32Timer_Output = HugeCalc::GetTimer( TIMER_UNIT_us );

	// 
	cout << endl << "The result of executing 1 + gcd(87324,78263148,7896) * (10^1989879887 mod 471!) is:" \
		<< endl << endl << lpShow << " (" << hugeResult.GetDigits() << " digits)" \
		<< endl << endl << "computation took " << u32Timer_Calc << " ms" \
		<< endl << "output conversion took " << u32Timer_Output << " us" \
		<< endl << endl;

	cout << endl << "潫ǰ 100 λʮ£" << endl << endl;
	system( "pause" );
	cout << endl;

	CHugeInt hugePrime((UINT32) 1 );
	hugePrime.DecLShift( 99 );	// = 10^99

	HugeCalc::EnableTimer( TRUE );
	HugeCalc::ResetTimer();

	for ( UINT32 i=0; i<100; ++i )
	{
		cout << endl << (LPCTSTR)hugePrime.NextPrime( hugePrime );
	}

	HugeCalc::EnableTimer( FALSE );

	cout << endl << "ʱΪ" << HugeCalc::GetTimerStr( FT_DOT06SEC_s ) << endl << endl;
	system( "pause" );

	return 0;
}
