// RSAToolDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSATool.h"
#include "RSAToolDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSAToolDlg dialog

CRSAToolDlg::CRSAToolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSAToolDlg::IDD, pParent)

#ifdef _RSA_ANSI_C	/*  *.dsp Ԥ */
	, m_RSA( new RSA )
#else
	, m_RSA( new CRSA )
#endif
{
	//{{AFX_DATA_INIT(CRSAToolDlg)
	m_u32KeyBits = DEFAULTBITS;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

#ifdef _RSA_ANSI_C
	RSA_Init( m_RSA );
#endif
}

void CRSAToolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSAToolDlg)
	DDX_Control(pDX, IDC_EDIT_E, m_heE);
	DDX_Control(pDX, IDC_EDIT_P, m_heP);
	DDX_Control(pDX, IDC_EDIT_Q, m_heQ);
	DDX_Control(pDX, IDC_EDIT_N, m_heN);
	DDX_Control(pDX, IDC_EDIT_EM, m_heEM);
	DDX_Text(pDX, IDC_EDIT_KEYBITS, m_u32KeyBits);
	DDV_MinMaxUInt(pDX, m_u32KeyBits, 32, 4096);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSAToolDlg, CDialog)
	//{{AFX_MSG_MAP(CRSAToolDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND_RANGE(IDC_RADIO_DEC, IDC_RADIO_HEX, OnSelRadix)
	ON_BN_CLICKED(IDC_BUTTON_CHEK_P, OnButtonChekP)
	ON_BN_CLICKED(IDC_BUTTON_CHEK_Q, OnButtonChekQ)
	ON_BN_CLICKED(IDC_BUTTON_GENERATE, OnButtonGenerate)
	ON_EN_KILLFOCUS(IDC_EDIT_E, OnKillfocusEditE)
	ON_EN_CHANGE(IDC_EDIT_P, OnChangeEditP)
	ON_EN_CHANGE(IDC_EDIT_Q, OnChangeEditQ)
	ON_EN_CHANGE(IDC_EDIT_N, OnChangeEditN)
	ON_EN_CHANGE(IDC_EDIT_OM, OnChangeEditOrginalMessage)
	ON_EN_CHANGE(IDC_EDIT_EM, OnChangeEditEncryptMessage)
	ON_EN_KILLFOCUS(IDC_EDIT_KEYBITS, OnKillfocusEditKeybits)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSAToolDlg message handlers

BOOL CRSAToolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	((CButton*)GetDlgItem( IDC_RADIO_HEX ))->SetCheck( BST_CHECKED );
	SetDlgItemText( IDC_EDIT_E, RSA_NORMALLY_STR );

	CString strVer;
	GetWindowText( strVer );
	strVer += " - ";
#ifdef _RSA_ANSI_C	/*  *.dsp Ԥ */
	strVer += HC_getVer();
#else
	strVer += HugeCalc::GetVer();
#endif

#ifdef _RSA_ANSI_C
	const HCLicenseLevel emnuLicenseLevel = HC_getLicenseLevel();
#else
	const HCLicenseLevel emnuLicenseLevel = HugeCalc::GetLicenseLevel();
#endif

	switch ( emnuLicenseLevel )
	{
	case HC_LICENSE_NONE:
		strVer += _T( " ( Unregistered )" );
		SetDlgItemText( IDC_EDIT_OM, _T( "Please register 'HugeCalc' at first." ));
		GetDlgItem( IDC_EDIT_E )->EnableWindow( FALSE );
		GetDlgItem( IDC_BUTTON_GENERATE )->EnableWindow( FALSE );
		break;

	case HC_LICENSE_DEMO:
		strVer += _T( " ( Unregistered )" );
		SetDlgItemText( IDC_EDIT_OM, _T( "Please register 'HugeCalc' at first." ));
		OnButtonGenerate();
		break;

	case HC_LICENSE_ALL:
	default:
		SetDlgItemText( IDC_EDIT_OM, _T( "Copyright by Guo Xianqiang." ));
		OnButtonGenerate();
	}

	SetWindowText( strVer );

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSAToolDlg::OnSelRadix(UINT nID)
{
	extern BOOL g_bHex;

	_RSA_SetHex( g_bHex = ( IDC_RADIO_HEX == nID ));

	SetDlgItemText( IDC_EDIT_E, _RSA_GetParam( RSA_E ));
	SetDlgItemText( IDC_EDIT_P, _RSA_GetParam( RSA_P ));
	SetDlgItemText( IDC_EDIT_Q, _RSA_GetParam( RSA_Q ));
	SetDlgItemText( IDC_EDIT_N, _RSA_GetParam( RSA_N ));
	SetDlgItemText( IDC_EDIT_D, _RSA_GetParam( RSA_D ));
	SetDlgItemText( IDC_EDIT_EM, _RSA_GetParam( RSA_EM ));

	return;
}

void CRSAToolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSAToolDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSAToolDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRSAToolDlg::OnKillfocusEditKeybits()
{
	// TODO: Add your control notification handler code here
	UpdateData();
}

void CRSAToolDlg::OnKillfocusEditE()
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData())
		return;

	CString strText;
	GetDlgItemText( IDC_EDIT_E, strText );
	const BYTE byStatus = _RSA_SetParam( (LPCTSTR)strText, RSA_E );

	if ( CHECK_FAIL_E( byStatus ))
	{
		MessageBox( _T( "E must be an odd number, and E > 1!" ), _T( "RSA - CHECK_E" ), MB_OK | MB_ICONERROR );

		GetDlgItem( IDC_EDIT_D )->EnableWindow( FALSE );
		GetDlgItem( IDC_EDIT_EM )->EnableWindow( FALSE );
		GetDlgItem( IDC_EDIT_DM )->EnableWindow( FALSE );
		GotoDlgCtrl( GetDlgItem( IDC_EDIT_E ));

		return;
	}

	GetDlgItem( IDC_BUTTON_CHEK_P )->EnableWindow( CHECK_FAIL_P(byStatus) || CHECK_FAIL_P_1(byStatus) );
	GetDlgItem( IDC_BUTTON_CHEK_Q )->EnableWindow( CHECK_FAIL_Q(byStatus) || CHECK_FAIL_Q_1(byStatus) );

	// P, Q, N, DM no change, but E --> D --> EM maybe changed
	RSAReady();
}

void CRSAToolDlg::OnButtonGenerate()
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData())
		return;

	GetDlgItem( IDC_BUTTON_GENERATE )->EnableWindow( FALSE );
	GetDlgItem( IDC_BUTTON_CHEK_P )->EnableWindow( FALSE );
	GetDlgItem( IDC_BUTTON_CHEK_Q )->EnableWindow( FALSE );

#ifdef _RSA_ANSI_C
	HC_enableTimer( TRUE );
	HC_resetTimer( 0, TIMER_UNIT_us );
#else
	HugeCalc::EnableTimer( TRUE );
	HugeCalc::ResetTimer( 0, TIMER_UNIT_us );
#endif

	if ( _RSA_GeneratePrime( &m_u32KeyBits ))
	{
	#ifdef _RSA_ANSI_C
		HC_enableTimer( FALSE );
		SetDlgItemText( IDC_TEXT_TIMER, HC_getTimerStr( FT_DOT06SEC_s ) );
	#else
		HugeCalc::EnableTimer( FALSE );
		SetDlgItemText( IDC_TEXT_TIMER, HugeCalc::GetTimerStr( FT_DOT06SEC_s ) );
	#endif

		SetDlgItemText( IDC_EDIT_P, _RSA_GetParam( RSA_P ));
		SetDlgItemText( IDC_EDIT_Q, _RSA_GetParam( RSA_Q ));

		RSAReady();

		// ûԱ༭ P,Q,N
		GetDlgItem( IDC_EDIT_P )->EnableWindow( TRUE );
		GetDlgItem( IDC_EDIT_Q )->EnableWindow( TRUE );
		GetDlgItem( IDC_EDIT_N )->EnableWindow( TRUE );
	}

	GetDlgItem( IDC_BUTTON_GENERATE )->EnableWindow( TRUE );

	const BYTE byStatus = _RSA_GetStatus();
	GetDlgItem( IDC_BUTTON_CHEK_P )->EnableWindow( CHECK_FAIL_P(byStatus) || CHECK_FAIL_P_1(byStatus) );
	GetDlgItem( IDC_BUTTON_CHEK_Q )->EnableWindow( CHECK_FAIL_Q(byStatus) || CHECK_FAIL_Q_1(byStatus) );
}

void CRSAToolDlg::OnChangeEditP()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO: Add your control notification handler code here
	GetDlgItem( IDC_EDIT_D )->EnableWindow( FALSE );
	GetDlgItem( IDC_EDIT_EM )->EnableWindow( FALSE );
	GetDlgItem( IDC_EDIT_DM )->EnableWindow( FALSE );

	GetDlgItem( IDC_BUTTON_CHEK_P )->EnableWindow( TRUE );
	SetDlgItemText( IDC_EDIT_DM, _T( "Please press the 'Set&Check - P' button" ));
}

void CRSAToolDlg::OnChangeEditQ()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO: Add your control notification handler code here
	GetDlgItem( IDC_EDIT_D )->EnableWindow( FALSE );
	GetDlgItem( IDC_EDIT_EM )->EnableWindow( FALSE );
	GetDlgItem( IDC_EDIT_DM )->EnableWindow( FALSE );

	GetDlgItem( IDC_BUTTON_CHEK_Q )->EnableWindow( TRUE );
	SetDlgItemText( IDC_EDIT_DM, _T( "Please press the 'Set&Check - Q' button" ) );
}

void CRSAToolDlg::OnButtonChekP()
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData())
		return;

//	GetDlgItem( IDC_EDIT_N )->EnableWindow( FALSE );

	CButton * const pButton = (CButton * const)GetDlgItem( IDC_BUTTON_CHEK_P );
	if ( !pButton->IsWindowEnabled())
	{
		return;
	}

	CString strText;
	GetDlgItemText( IDC_EDIT_P, strText );
	const BYTE byStatus = _RSA_SetParam( (LPCTSTR)strText, RSA_P );

	if ( CHECK_FAIL_PQ( byStatus ))
	{
		MessageBox( _T( "P can not equal to Q!" ), _T( "RSA - CHECK_PQ" ), MB_OK | MB_ICONERROR );
	}
	else if ( CHECK_FAIL_P( byStatus ))
	{
		MessageBox( _T( "P is not a prime number!" ), _T( "RSA - CHECK_P" ), MB_OK | MB_ICONERROR );
	}
	else if ( CHECK_FAIL_P_1( byStatus ))
	{
		MessageBox( _T( "Gcd( P-1, E ) <> 1 !" ), _T( "RSA - CHECK_P_1" ), MB_OK | MB_ICONERROR );
	}
	else
	{
		pButton->EnableWindow( FALSE );
		RSAReady();
	}
}

void CRSAToolDlg::OnButtonChekQ()
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData())
		return;

//	GetDlgItem( IDC_EDIT_N )->EnableWindow( FALSE );

	CButton * const pButton = (CButton * const)GetDlgItem( IDC_BUTTON_CHEK_Q );
	if ( !pButton->IsWindowEnabled())
	{
		return;
	}

	CString strText;
	GetDlgItemText( IDC_EDIT_Q, strText );
	const BYTE byStatus = _RSA_SetParam( (LPCTSTR)strText, RSA_Q );

	if ( CHECK_FAIL_PQ( byStatus ))
	{
		MessageBox( _T( "Q can not equal to P!" ), _T( "RSA - CHECK_PQ" ), MB_OK | MB_ICONERROR );
	}
	else if ( CHECK_FAIL_Q( byStatus ))
	{
		MessageBox( _T( "Q is not a prime number!" ), _T( "RSA - CHECK_Q" ), MB_OK | MB_ICONERROR );
	}
	else if ( CHECK_FAIL_Q_1( byStatus ))
	{
		MessageBox( _T( "Gcd( Q-1, E ) <> 1 !" ), _T( "RSA - CHECK_Q_1" ), MB_OK | MB_ICONERROR );
	}
	else
	{
		pButton->EnableWindow( FALSE );
		RSAReady();
	}
}

void CRSAToolDlg::RSAReady()
{
	// TODO: Add your control notification handler code here
	if ( RSA_READY( _RSA_GetStatus() ))
	{
		GetDlgItem( IDC_EDIT_D )->EnableWindow( TRUE );
		GetDlgItem( IDC_EDIT_EM )->EnableWindow( TRUE );
		GetDlgItem( IDC_EDIT_DM )->EnableWindow( TRUE );
		MessageBeep( MB_OK );

		// ע⣺δעû˴صִС<HugeCalc>ĸ
		// ӰִڲݲӰ죬ԲӰܶ
//		SetDlgItemText( IDC_EDIT_P, _RSA_GetParam(RSA_P ));
//		SetDlgItemText( IDC_EDIT_Q, _RSA_GetParam( RSA_Q ));
		SetDlgItemText( IDC_EDIT_N, _RSA_GetParam( RSA_N ));
		SetDlgItemText( IDC_EDIT_D, _RSA_GetParam( RSA_D ));

		CString strText;
		const UINT32 u32NBits = _RSA_GetParamBits( RSA_N );
		strText.Format( _T( "%u bits " ), u32NBits );
		SetDlgItemText( IDC_TEXT_NBITS, strText );

		if ( m_u32KeyBits < u32NBits && u32NBits <= MAXBITS )
		{
			m_u32KeyBits = u32NBits;
			UpdateData( FALSE );
		}

		OnChangeEditOrginalMessage();
	}
	else
	{
		GetDlgItem( IDC_EDIT_D )->EnableWindow( FALSE );
		GetDlgItem( IDC_EDIT_EM )->EnableWindow( FALSE );
		GetDlgItem( IDC_EDIT_DM )->EnableWindow( FALSE );
	}
}

void CRSAToolDlg::OnChangeEditN()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO: Add your control notification handler code here
	if ( !UpdateData())
		return;

	GetDlgItem( IDC_EDIT_P )->EnableWindow( FALSE );
	GetDlgItem( IDC_EDIT_Q )->EnableWindow( FALSE );
	GetDlgItem( IDC_BUTTON_CHEK_P )->EnableWindow( FALSE );
	GetDlgItem( IDC_BUTTON_CHEK_Q )->EnableWindow( FALSE );

	GetDlgItem( IDC_EDIT_D )->EnableWindow( FALSE );
	SetDlgItemText( IDC_EDIT_D, _T( "???" ) );

	GetDlgItem( IDC_EDIT_EM )->EnableWindow( TRUE );
	GetDlgItem( IDC_EDIT_DM )->EnableWindow( FALSE );

	CString strText;
	GetDlgItemText( IDC_EDIT_N, strText );
	_RSA_SetParam( (LPCTSTR)strText, RSA_N );

	const UINT32 u32NBits = _RSA_GetParamBits( RSA_N );
	strText.Format( _T( "%u bits " ), u32NBits );
	SetDlgItemText( IDC_TEXT_NBITS, strText );

	if ( m_u32KeyBits < u32NBits && u32NBits <= MAXBITS )
	{
		m_u32KeyBits = u32NBits;
		UpdateData( FALSE );
	}

	OnChangeEditOrginalMessage();
}

void CRSAToolDlg::OnChangeEditOrginalMessage()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO: Add your control notification handler code here
	CString strText;
	GetDlgItemText( IDC_EDIT_OM, strText );
	const LPCTSTR lpszOrgText = (LPCTSTR)strText;

	CString strLength;
	strLength.Format( _T( "%u chars " ), strlen( lpszOrgText ));
	SetDlgItemText( IDC_TEXT_MLEN, strLength );

	const BYTE byStatus = _RSA_SetParam( lpszOrgText, RSA_OM );
	const LPCTSTR lpszEncrypt = _RSA_EncryptMessage( lpszOrgText );
	SetDlgItemText( IDC_EDIT_EM, lpszEncrypt );

	if ( !RSA_READY( byStatus ))
	{
		SetDlgItemText( IDC_EDIT_DM, _T( "Please press the 'Generate' button" ) );
		return;
	}

	if ( CHECK_FAIL_M( byStatus ))
	{
		SetDlgItemText( IDC_EDIT_DM, _T( "Max. length(chars) of message can be (Keysize/8)-1, to make sure that M < N." ) );
	}
	else
	{
		SetDlgItemText( IDC_EDIT_DM, _RSA_DecryptMessage( lpszEncrypt ) );
	}
}

void CRSAToolDlg::OnChangeEditEncryptMessage()
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.

	// TODO: Add your control notification handler code here

	if ( !UpdateData() )
	{
		return;
	}
	UpdateData( FALSE );

	CString strText;
	GetDlgItemText( IDC_EDIT_EM, strText );
	const BYTE byStatus = _RSA_SetParam( (LPCTSTR)strText, RSA_EM );

	if ( !RSA_READY( byStatus ))
	{
		SetDlgItemText( IDC_EDIT_DM, _T( "Please press the 'Generate' button" ) );
		return;
	}

	if ( CHECK_FAIL_M( byStatus ))
	{
		SetDlgItemText( IDC_EDIT_DM, _T( "Max. length(chars) of message can be (Keysize/8)-1, to make sure that M < N." ) );
	}
	else
	{
		SetDlgItemText( IDC_EDIT_DM, _RSA_DecryptMessage( (LPCTSTR)strText ) );
	}
}

void CRSAToolDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
#ifdef _RSA_ANSI_C
	RSA_free( m_RSA );
#endif

	delete m_RSA;
}
