// RSAToolDlg.h : header file
//

#if !defined(AFX_RSATOOLDLG_H__4BB62775_185F_4583_A84E_460494222CA8__INCLUDED_)
#define AFX_RSATOOLDLG_H__4BB62775_185F_4583_A84E_460494222CA8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CRSAToolDlg dialog
#ifdef _RSA_ANSI_C	/*  *.dsp Ԥ */
	#include "RSA.h"
#else
	#include "RSA.hpp"
#endif

#include "HexEdit.h"

class CRSAToolDlg : public CDialog
{
// Construction
public:
	CRSAToolDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRSAToolDlg)
	enum { IDD = IDD_RSATOOL_DIALOG };
	UINT32	m_u32KeyBits;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRSAToolDlg)
	public:
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRSAToolDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg VOID OnSelRadix(UINT nID);
	afx_msg void OnButtonChekP();
	afx_msg void OnButtonChekQ();
	afx_msg void OnButtonGenerate();
	afx_msg void OnKillfocusEditE();
	afx_msg void OnChangeEditP();
	afx_msg void OnChangeEditQ();
	afx_msg void OnChangeEditN();
	afx_msg void OnChangeEditOrginalMessage();
	afx_msg void OnChangeEditEncryptMessage();
	afx_msg void OnKillfocusEditKeybits();
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void RSAReady();

private:

#ifdef _RSA_ANSI_C	/*  *.dsp Ԥ */
	RSA * const		m_RSA;
#else
	CRSA * const	m_RSA;
#endif

	CHexEdit	m_heE;
	CHexEdit	m_heP;
	CHexEdit	m_heQ;
	CHexEdit	m_heN;
	CHexEdit	m_heEM;
};

#ifdef _RSA_ANSI_C	/*  *.dsp Ԥ */

	#define _RSA_SetHex( bHex )							RSA_SetHex( m_RSA, bHex )

	#define _RSA_GeneratePrime( pKeyBits )				RSA_GeneratePrime( m_RSA, pKeyBits )

	#define _RSA_SetParam( lpszString, enumRSAParam )	RSA_SetParam( m_RSA, lpszString, enumRSAParam )
	#define _RSA_GetStatus()							RSA_GetStatus( m_RSA )

	#define _RSA_GetParam( enumRSAParam )				RSA_GetParam( m_RSA, enumRSAParam )
	#define _RSA_GetParamBits( enumRSAParam )			RSA_GetParamBits( m_RSA, enumRSAParam )

	#define _RSA_EncryptMessage( lpszText )				RSA_EncryptMessage( m_RSA, lpszText )
	#define _RSA_DecryptMessage( lpszHexNum )			RSA_DecryptMessage( m_RSA, lpszHexNum )

#else

	#define _RSA_SetHex( bHex )							m_RSA->SetHex( bHex )

	#define _RSA_GeneratePrime( pKeyBits )				m_RSA->GeneratePrime( pKeyBits )

	#define _RSA_SetParam( lpszString, enumRSAParam )	m_RSA->SetParam( lpszString, enumRSAParam )
	#define _RSA_GetStatus()							m_RSA->GetStatus()

	#define _RSA_GetParam( enumRSAParam )				m_RSA->GetParam( enumRSAParam )
	#define _RSA_GetParamBits( enumRSAParam )			m_RSA->GetParamBits( enumRSAParam )

	#define _RSA_EncryptMessage( lpszText )				m_RSA->EncryptMessage( lpszText )
	#define _RSA_DecryptMessage( lpszHexNum )			m_RSA->DecryptMessage( lpszHexNum )

#endif

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RSATOOLDLG_H__4BB62775_185F_4583_A84E_460494222CA8__INCLUDED_)
